/**
 * @(#)Connection.java
 *
 *
 * @author Proyecto *** Polaris ***
 * @version 1.00 2007/1/22
 *
 * Esta clase sirve para conectar a una BD
 * desde Java generalmente
 *
 */

package Utils; 
 
import java.sql.*;
import javax.swing.JOptionPane;

public class conexion {

	// Propiedades
	
	String bd;
	String login;
	String password;
	String url;
	String tabla;
	//
	Connection conn;
	Statement st;
	ResultSet rs;
        //
        String msj;
	
	
	// Metodos
	
	public void conexion(){
		// Cargar variables en ceros
		bd="";
		login="";
		password="";
		url="jdbc:postgresql://localhost/";
		// null a los objetos
		conn = null;
	    st   = null;
		rs   = null;		
	}

   public void conectar(String BD, String Usuario, String Contrasena){
       msj="";
   		bd=BD;
   		login=Usuario;
   		password=Contrasena;
   		// Anadir a la url la bd user y contrasena
   		url = "jdbc:postgresql://localhost/" + bd;   	
   		// conectar
   		try{
   			
   			try{
   				// seleccionar SGBD
   				Class.forName("org.postgresql.Driver").newInstance();   				   				
   			}catch(Exception ex){
   				System.out.println(ex.getMessage());   		
                                //System.out.println("aqui 1");
                                msj= "ERROR: " + ex.getMessage();
   			}
   			
   			// Realizar la conexion
   			conn=DriverManager.getConnection(url, login, password);
   			
   			if(conn != null){
   				System.out.println("Conexion a base de datos " + url + " ... OK");
                                //msj= "Connected to Data Base " + url + " ... OK";
   				
   			}
   		}catch(SQLException ex){
   			System.out.println(ex.getMessage());   				
                        //System.out.println("aqui 2");
                        msj= "ERROR: " + ex.getMessage();
   		}
   }
   
   public void cerrarConexion(){
       msj="";
        if(conn!=null){
            try{
                if (!conn.isClosed()) {    		
                        // cerrar conexion			
                        conn.close(); 
                        System.out.println("Se cerro conexion a: " + url + " ... OK");   					  
                        msj= "Close conection " + url + " ... OK";
                }	
            }catch(SQLException ex){
                System.out.println(ex.getMessage());   		
                msj= "ERROR: " + ex.getMessage();
            }
        }		
   	
   }
   
   // Funciones
   
   // consulta    	
   public ResultSet consulta(String query){
    	msj="";
        try{
            if (conn != null) {    		
                st = conn.createStatement();
                rs = st.executeQuery(query);
                return rs;
                //if(rs!=null) msj= ""
            }
            else {
                msj= "There don't exist connection";
                  return null;                  
            }	
        }catch(SQLException ex){
                System.out.println(ex.getMessage());
                msj= "ERROR: " + ex.getMessage();
                return null;
        }       
   	
   }
   
   public ResultSet consulta1(String query){
    	msj="";
        try{
			if (conn != null) {    		
	    		
	    		st = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
	    		rs = st.executeQuery(query);
	    		return rs;
	    		           
	        }
	        else {
                      msj= "There don't exist connection";      
	        	return null;
	        }	
		}catch(SQLException ex){
   			System.out.println(ex.getMessage());   				
                        msj= "ERROR: " + ex.getMessage();
   			return null;
   		}       
   	
   }
   
   public int non_query(String query){
       msj="";
    	PreparedStatement stmt=null;
   		int reg;   		
   		reg=0;
   		try{
                    if (conn != null) {    		

                    stmt=conn.prepareStatement(query);		
                    reg=stmt.executeUpdate();	    		
                    //if(reg<0) System.out.println("No se dio");
                    stmt.close(); 	    			    
	        }
	        
		}catch(SQLException ex){
                    msj= "ERROR: " + ex.getMessage();
   			System.out.println(ex.getMessage());  
                    JOptionPane.showMessageDialog(null, ex.getMessage(), 
                    "Database Connection", JOptionPane.ERROR_MESSAGE);
                    cargarScript.msjbd="ERROR:";
   		} 
   	return reg;
   }
   
     
   // insertar
   public String insertar(String Tabla, String elementos, String registro){   	
       msj="";
   		int reg=1;
   		String exito;
   		
   		try{
			if (conn != null) {    		
	    		//INSERT INTO films (code, title, did, date_prod, kind)
    			//		VALUES ('T_601', 'Yojimbo', 106, DATE '1961-06-16', 'Drama');
    			st= conn.createStatement();
	    		st.execute("INSERT INTO " + Tabla + " (" + elementos + ") VALUES (" + registro + ")");		    		
	    		if(reg>0){
	    			exito= "true";
	    		}else{
	    			exito= "false";
	    		}   
	    		st.close();     
	        }
	        else {
	        	exito= "false";
                        msj= "ERROR: There don't exist connection...";
	        }	
		}catch(SQLException ex){
   			System.out.println(ex.getMessage());   				
                        System.out.println("numero: " + ex.getErrorCode());
   			exito= ex.getMessage();
                        msj= "ERROR: " + ex.getMessage();
   		}
   		
   		//System.out.println("Lo logro: " + exito);
   		return exito;
   }
   
   // eliminar
   public void eliminar(String Tabla, String condicion){
       msj="";
   		PreparedStatement stmt=null;
   		int reg;
   		
   		try{
			if (conn != null) {    		
	    		// delete from mitabla where clave = "+clave; troncate nombre tabla
	    		stmt=conn.prepareStatement("DELETE FROM " + Tabla + " WHERE " + condicion);		
	    		reg=stmt.executeUpdate();
	    		if(reg>0){
	    			//System.out.println("Listo eliminado... ");   				
	    		}else{
	    			//System.out.println("No se elimino... ");   				
	    		}   
	    		stmt.close();     
	        }
	        else {
	        	System.out.println("No hay conexion");   				
                        msj= "ERROR: There don't exist connection";
	        }	
		}catch(SQLException ex){
   			System.out.println(ex.getMessage());   				
   			msj= "ERROR: " + ex.getMessage();
   		}	
   }
   
   // modificar
   public void modificar(String Tabla, String campos, String donde){
       msj="";
   		PreparedStatement stmt=null;
   		int reg;
   		
   		try{
			if (conn != null) {    		
	    		// UPDATE mitabla SET "+ "NOMBRE='"+ nombre+ "', EDAD="+ edad+",estatura="+estatura+" WHERE clave=" + clave+";
	    		stmt=conn.prepareStatement("UPDATE " + Tabla + " SET " + campos + " WHERE " + donde);		
	    		reg=stmt.executeUpdate();
	    		if(reg>0){
	    			//System.out.println("Listo modificado... ");   				
	    		}else{
	    			//System.out.println("No se modifico " + campos + "... ");   				
	    		}   
	    		stmt.close();     
	        }
	        else {
	        	System.out.println("No hay conexion");   				
                        msj= "ERROR: There don't exist connection";
	        }	
		}catch(SQLException ex){
   			System.out.println(ex.getMessage());   				
   			msj= "ERROR: " + ex.getMessage();
   		}	
   }
   
   public String getMensaje(){
       return msj;
   }
   
   public void setMensaje(String mens){
       msj= mens;
   }
	    
   
}
