/*
 * build_decisionTree.java
 *
 * Created on 22 de junio de 2007, 10:25 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification.mate;

import algorithm.classification.ClassificationTableModel;
import algorithm.classification.clasesAtrib;
import algorithm.classification.elemento;
import algorithm.classification.sesiontrans;
import java.util.ArrayList;
import java.util.Vector;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class build_decisionTree { 
    
    // ***
    String claseT; // Clase Target o punto de decision    
    clasesAtrib valorPerAtrib;
    int colT;
    ArrayList indTam;
    // ***    
    
    /** Creates a new instance of build_decisionTree */
    public build_decisionTree(String Target, int indT, clasesAtrib cAtrib) {
        claseT= Target;        
        colT= indT;
        valorPerAtrib= cAtrib;
    }
    
    /** Construir tabla de combinaciones */
    public MateTableModel getTablaMate(ClassificationTableModel examples, ArrayList atributes){
        MateTableModel tMate=null;
        sesiontrans fila, newfila;
        ArrayList newdatos= new ArrayList(), combdatos;
        mateFila nuevaFila;
        //
        int i,j, n=examples.getRowCount() , colT=examples.getColumnIndex(claseT);
        String dato, datoT;
        //
        int ncomb=0, auxd, auxn, p, ncol= examples.getColumnCount();
        indTam= new ArrayList();
        //
        for(i=0;i<n;i++){
            fila= examples.getSesionAt(i);
            dato=""; datoT="";
            nuevaFila= new mateFila();
            // Sacar el dato de target
            switch(colT){
                case 0:
                    datoT= fila.getTipoIP();
                    nuevaFila.setTipoIP(datoT);
                    break;
                case 1:
                    datoT= fila.getHorario();
                    nuevaFila.setHorario(datoT);
                    break;
                case 2:
                    datoT= fila.getDiaSemana();
                    nuevaFila.setDiaSemana(datoT);
                    break;
                case 3:
                    datoT= fila.getDuracion();
                    nuevaFila.setDuracion(datoT);
                    break;
                case 4:
                    datoT= fila.getCantPet();
                    nuevaFila.setCantPet(datoT);
                    break;
                case 5:
                    datoT= fila.getTamDescarga();
                    nuevaFila.setTamDescarga(datoT);
                    break;
            }
            newdatos= this.getCombinaciones(newdatos,fila,0,ncol,nuevaFila);
            //
        }
        tMate= new MateTableModel(newdatos);
        tMate.indTam= indTam;
        //
        return tMate;
    }
    
    /** Hace las respectivas combinaciones de una fila */
    public ArrayList getCombinaciones(ArrayList combs, sesiontrans fila,int desde, int tcol, mateFila oldfila){
        int i;
        mateFila newfila= new mateFila();
        //
        for(i=desde; i<tcol; i++){
            if(i!=colT){
                newfila= this.copiarValores(oldfila);
                newfila= this.setValor(i,newfila,this.Valor(i,fila));
                combs= agregar_aVector(combs, newfila);
                combs= this.getCombinaciones(combs,fila,i+1,tcol,newfila);
                newfila=null; newfila= new mateFila();
            }                
        }
        //
        return combs;
    }
    
    /** Copia valores de otra mateFila */
    public mateFila copiarValores(mateFila oldfila){
        mateFila nueFila= new mateFila();
        //
        nueFila.setTipoIP(oldfila.getTipoIP());
        nueFila.setHorario(oldfila.getHorario());
        nueFila.setDiaSemana(oldfila.getDiaSemana());
        nueFila.setDuracion(oldfila.getDuracion());
        nueFila.setCantPet(oldfila.getCantPet());
        nueFila.setTamDescarga(oldfila.getTamDescarga());
        //
        return nueFila;
    }
    
    /** Agrega a Array de combinaciones totales */
    public ArrayList agregar_aVector(ArrayList comb, mateFila nueFila){
        int i,j,tam,indTmenor,indTmayor,k;
        mateFila aux;
        boolean esIgual=false, yaAdd;
        //
        if(comb.size()>0){
        tam= nueFila.getTamano();        
        for(j=0;j<indTam.size();j++){
            if(j+2==tam){
                indTmenor= Integer.parseInt(indTam.get(j).toString());
                try{
                    indTmayor= Integer.parseInt(indTam.get(j+1).toString());
                }catch(Exception e){
                    indTmayor= comb.size();
                }
                esIgual=false;
                for(i=indTmenor;i<indTmayor && esIgual==false;i++){
                    aux= (mateFila) comb.get(i);
                    esIgual= aux.isSame(nueFila);
                    if(esIgual){
                        aux.incConteo();
                        comb.remove(i);
                        comb.add(i,aux);
                    }
                }
                if(esIgual==false){
                    // Agrego el nuevo elemento de este tamano
                    comb.add(indTmayor,nueFila);
                    for(i=j+1;i<indTam.size();i++){
                        indTmayor= Integer.parseInt(indTam.get(i).toString());
                        indTmayor++;
                        indTam.remove(i);
                        indTam.add(i,indTmayor);
                    }
                    yaAdd=true;
                }
                //
                return comb;
            }           
        }
        //
        comb.add(nueFila);
        indTam.add(comb.size() - 1);
        //
        }
        //
        else{
            comb.add(nueFila);
            indTam.add(0);
        }        
        //
        return comb;
    }
    
    /** Coloca un nuevo valor en nuefila */
    public mateFila setValor(int indice, mateFila nuefila, String dato){
        switch(indice){
                case 0:
                    nuefila.setTipoIP(dato);
                    break;
                case 1:
                    nuefila.setHorario(dato);
                    break;
                case 2:
                    nuefila.setDiaSemana(dato);
                    break;
                case 3:
                    nuefila.setDuracion(dato);
                    break;
                case 4:
                    nuefila.setCantPet(dato);
                    break;
                case 5:
                    nuefila.setTamDescarga(dato);
                    break;
        }
        nuefila.incConteo();
        //
        return nuefila;
    }
    
    /** Obtiene un valor de una fila */
    public String Valor(int indice, sesiontrans fila){
        String datoT="";
        //
        switch(indice){
                case 0:
                    datoT= fila.getTipoIP();
                    break;
                case 1:
                    datoT= fila.getHorario();
                    break;
                case 2:
                    datoT= fila.getDiaSemana();
                    break;
                case 3:
                    datoT= fila.getDuracion();
                    break;
                case 4:
                    datoT= fila.getCantPet();
                    break;
                case 5:
                    datoT= fila.getTamDescarga();
                    break;
        }
        //
        return datoT;
    }
    
    /** Construir arbol */
    public elemento  decisionTree(MateTableModel tableMate, int nivel, ArrayList atributes, elemento porDefecto) {
        // *** 
        int i;        
        elemento raizA, aux; // arbol
        elemento subarbol, sameCla, mejor; // subarbol
        String valorI=""; // mejor atributo, valor de i
        Vector valores; // valores del mejor atributo
        ArrayList atributosFaltantes;
        MateTableModel tableMateVi;
        // ***
        sameCla= isSameClassification(tableMate, nivel,atributes.size());
        if(tableMate.getRowCount()==0){            
            return porDefecto;
        }
        else if(sameCla!=null){            
            return sameCla;
        }
        else if(atributes.size()==0){
            return valorMayoritario(tableMate, nivel);
        }
        else{  
            mejor= escogeAtributo(atributes, tableMate, nivel);
            raizA= new elemento(mejor.getNombre());
            valores= valorPerAtrib.getValores(mejor.getNombre());
            //      
            for(i=0;i<valores.size();i++){
                valorI= valores.elementAt(i).toString();
                // 1. Sacamos la tabla para el valor - 2. Quitamos a mejor de los Atrib Condicion - 3. Vamos a la rama
                tableMateVi= obtenerEjemplosVi(tableMate, nivel, mejor.getNombre(), valorI);
                atributosFaltantes= sacarMejor(atributes, mejor.getNombre());                
                subarbol= decisionTree(tableMateVi, nivel+1, atributosFaltantes, valorMayoritario(tableMate, nivel));
                // Pongo el valor como hijo de raiz, y a subarbol como hijo de valor
                aux= new elemento(valorI);
                aux.hijos[0]= subarbol;
                raizA.hijos[i]= aux;
                raizA.incNumhijos();                
            }
            return raizA;  
        }
        //
    }
    //
    
    // NO CUADRAN LOS INDICES
    /** Lo primero es eliminar los actuales del nivel actual */
    public MateTableModel obtenerEjemplosVi(MateTableModel ejemplos, int nivel, String mejorA, String valori){
        MateTableModel answer=null;
        mateFila fila;
        ArrayList newdatos= new ArrayList();        
        ArrayList newind= new ArrayList();
        int i, desde, n=ejemplos.getRowCount() , colmejor=ejemplos.getColumnIndex(mejorA), hasta;
        String dato;
        //System.out.println("Tamano: " + ejemplos.indTam.size() + " * Nivel: " + nivel );
        try{
            desde= Integer.parseInt(ejemplos.indTam.get(nivel+1).toString());
        }catch(Exception e){
            desde= 0;
        }        
        try{
            hasta= Integer.parseInt(ejemplos.indTam.get(nivel+2).toString());
        }catch(Exception e){
            hasta= ejemplos.getRowCount();
        }        
        //   
        for(i=0;i<=nivel+1;i++){
            newind.add(0);
        }        
        //
        int niv= nivel + 2;
        //System.out.println(":: NUEVA TABLA ::");
        for(i=desde;i<n;i++){
            fila= ejemplos.getSesionAt(i);
            dato="";
            //
            switch(colmejor){
                case 0:
                    dato= fila.getTipoIP();
                    break;
                case 1:
                    dato= fila.getHorario();
                    break;
                case 2:
                    dato= fila.getDiaSemana();
                    break;
                case 3:
                    dato= fila.getDuracion();
                    break;
                case 4:
                    dato= fila.getCantPet();
                    break;
                case 5:
                    dato= fila.getTamDescarga();
                    break;
            }
            //
            if(dato.equals(valori)){
                if(fila.getTamano()>(niv+1)){
                    newind.add(newdatos.size());
                    niv++;                
                }
                //
                newdatos.add(fila);
//                System.out.println("Fila " + i + ": " + fila.getTipoIP() + " * " + fila.getHorario() + " * "
//                + fila.getDiaSemana() + " * " + fila.getDuracion() + " * " + fila.getCantPet() + " - " 
//                + fila.getTamDescarga() + " :: " + fila.getConteo()); 
            }
        }
        //
        answer= new MateTableModel(newdatos);        
        answer.indTam= newind;
        //
        return answer;
    }
    
    /** sacar mejor */
    public ArrayList sacarMejor(ArrayList atributos, String mejor){
        atributos.remove(mejor);
        return atributos;
    }//
    
    /** escoger Mejor Atributo */
    public elemento escogeAtributo(ArrayList atributos, MateTableModel tMate, int n){
        String better="", nomA, dato, datoT, valorI, valorT;
        int i,j,k,w,colA, desde, hasta, nValor, nAtrib, colN;
        double menorE, eni, eniv;        
        boolean findit;
        Vector valores= new Vector();
        Vector valoresT= new Vector();
        Vector conteos, entro;
        elemento mejorAtributo= new elemento("");
        entropiaAtributo entroA;
        //
        valoresT= valorPerAtrib.getValores(claseT);
        colN= tMate.getColumnIndex("Count");
        menorE= 100.0;
        desde= Integer.parseInt(tMate.indTam.get(n).toString()); // desde donde inicia el tamano
        try{
            hasta= Integer.parseInt(tMate.indTam.get(n+1).toString()); // hasto donde inicia el tamano +1        
        }catch(Exception e){
            hasta= tMate.getRowCount();
        } entro= new Vector();
        // Analizar la entropia para cada atributo
        for(i=0;i<atributos.size();i++){
            // Saco atributo de indice i
            nomA= atributos.get(i).toString();
            colA= tMate.getColumnIndex(nomA);
            valores= valorPerAtrib.getValores(nomA);
            // Calculo la entropia de este atributo
            eni= 0; nAtrib= 0; entro.removeAllElements(); 
            for(j=0;j<valores.size();j++){
                valorI= valores.elementAt(j).toString();
                eniv=0; nValor=0; conteos= new Vector();
                // para cda valor de la clase target
                for(w=0;w<valoresT.size();w++){
                    valorT= valoresT.elementAt(w).toString();
                    findit= false;
                    //                
                    for(k=desde;k<hasta && findit==false;k++){
                        dato= tMate.getValueAt(k,colA).toString();
                        datoT= tMate.getValueAt(k,colT).toString();
                        if(valorI.equals(dato) && valorT.equals(datoT)){
                            conteos.add(tMate.getValueAt(k,colN));
                            nValor= nValor + Integer.parseInt(tMate.getValueAt(k,colN).toString());
                            findit= true;
                        }
                    }
                }
                nAtrib= nAtrib + nValor;
                //
                eniv= calcularE(conteos, nValor);
                entroA= new entropiaAtributo(nValor,eniv);
                entro.add(entroA);
            }
            eni= calcularEntropia(nAtrib, entro);
            //
            if(eni<menorE){
                menorE=eni;
                better= nomA;
                mejorAtributo= new elemento(better, menorE, nAtrib);
            }
            //
        }
        if(better==""){
            mejorAtributo= null;
        }
        //
        return mejorAtributo;
    }//
    
    /** Calcular entropia total de valor */
    public double calcularEntropia(int nA, Vector entro){
        double entropia=0.0, operar;
        entropiaAtributo entroA;
        int i;
        //
        for(i=0;i<entro.size();i++){
            entroA= (entropiaAtributo) entro.elementAt(i);
            operar= Double.parseDouble(String.valueOf(entroA.getNum()))/nA;
            operar= operar * entroA.getEntro();
            entropia= entropia + operar;
        }
        //
        return entropia;        
    }
        
    /** Calcular entropia de valor-valortarget */
    public double calcularE(Vector conteo, int nV){
        double entropia=0.0;
        double operar;
        String nvalue;
        //
        for(int i=0;i<conteo.size();i++){
            nvalue= conteo.elementAt(i).toString();
            //
            operar= Double.parseDouble(nvalue)/nV;
            entropia= entropia + (operar*log2(operar));
            //
        }
        //
        return entropia*-1;        
    }
    
    // Calcula log en base dos
    public double log2(double value){
        if(value == 0.0) return 0.0;
        return Math.log(value)/Math.log(2);
    }
    
    // -* Valor Mayoritario de la clase /// FALTA CORREGIR y casi acabo
    public elemento valorMayoritario(MateTableModel examples, int n){
       elemento valorMayor= null;
        Vector etiquetas, numetiq;
        //mateFila verTam;
        //
        boolean isSame=true;
        int i,j,c,desde,hasta,colN,tam,ntam,ct;
        String dato,detiq;
        etiquetas= valorPerAtrib.getValores(claseT);
        numetiq= new Vector(etiquetas.size());
        colN= examples.getColumnIndex("Count");
        //
//        desde= Integer.parseInt(examples.indTam.get(n).toString()); // desde donde inicia el tamano        
//        try{
//            hasta= Integer.parseInt(examples.indTam.get(n+1).toString()); // hasto donde inicia el tamano +1        
//        }catch(Exception e){
//            hasta= examples.getRowCount();
//        }
        ntam= examples.getSesionAt(0).getTamano();        tam= ntam;
        //
        for(i=0;i<etiquetas.size();i++){
            numetiq.addElement(0);
        }
        //
        i=0; //System.out.println(".:. VALORES PROB IGUALES .:.");
        while(ntam==tam && i<examples.getRowCount()){
            dato= examples.getValueAt(i,colT).toString();
            //System.out.println("dato " + i + ": " + dato);
            isSame=false;
            for(j=0;j<etiquetas.size() && isSame==false;j++){
                detiq= etiquetas.elementAt(j).toString();
                if(detiq.equals(dato)){
                    isSame= true;
                    ct= Integer.parseInt(numetiq.get(j).toString());
                    c= Integer.parseInt(examples.getValueAt(i,colN).toString());
                    c += ct;
                    numetiq.remove(j);
                    numetiq.add(j,c);
                }
            } 
            //
            i++; //System.out.println("indice: " + i);
            if(i<examples.getRowCount()) tam= examples.getSesionAt(i).getTamano();
        }
        c= Integer.parseInt(numetiq.elementAt(0).toString()); j=0;
        for(i=1;i<numetiq.size();i++){
            if(c< Integer.parseInt(numetiq.elementAt(i).toString())){
                c= Integer.parseInt(numetiq.elementAt(i).toString());
                j=i;
            }            
        }        
        //
        valorMayor= new elemento(etiquetas.elementAt(j).toString(),Integer.parseInt(numetiq.elementAt(j).toString()));
        return valorMayor;
    }//
    
    /** Igual Clasificacion */
    public elemento isSameClassification(MateTableModel examples, int n, int cantA){
       elemento igual=null;
       //
       boolean isSame=true;
       int i,desde,hasta,c,ct=0;
       String dato, predato="";
       //
       desde= Integer.parseInt(examples.indTam.get(n).toString()); // desde donde inicia el tamano
        try{
            hasta= Integer.parseInt(examples.indTam.get(n+1).toString()); // hasto donde inicia el tamano +1                    
        }catch(Exception e){
            hasta= examples.getRowCount();
        }
       //
        if(examples.getRowCount()>0)
        predato= examples.getValueAt(desde,colT).toString();
        c=0; //ct= hasta-desde;
        for(i=0;i<hasta && isSame==true;i++){
            dato= examples.getValueAt(i,colT).toString();
            if(dato.equals(predato)){
                c++;
            }else{
                isSame=false;
            }            
        }
        
        //Coloco ct
        if(cantA>1) {   ct= c/(cantA-1);    }
        else        {   ct= c;              }
        
        // aca ingreso el dato principal
        if(isSame){
          igual= new elemento(predato);  
          igual.setFrecuence(ct);
        }
       //
       return igual;
    }//
    
}

/** Clase para calcular la entropia del Atributo analizado */
class entropiaAtributo{
    int num;
    double entro;
    
    public entropiaAtributo(int n, double e){
        num= n;
        entro= e;
    }
    
    public int getNum(){
        return num;
    }
    
    public double getEntro(){
        return entro;
    }
}