/*
 * SE ADMINISTRAN LOS NODOS DEL GRAFICO
 * SE DIBUJAN CADA UNO DE ESTOS NODOS
 */

package polaris2.graph;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import workspace.Main_Set.Main;
/**
 *
 * @author santos
 */
public class area_trabajo extends JPanel  {

    public Nodo pri_nodo=null;
    public Nodo ult_nodo=null;
    public Nodo origen=null;
    public Nodo arrastrado=null;
    public Nodo encontrado=null;
    public int arrastrando=0;
    public int conectando=0;
    public int posX_raton=0;
    public int posY_raton=0;
    public Image foto1a,foto2a,foto3a,foto4a,foto5a,foto6a,foto7a,foto8a,foto9a,foto10a,foto11a,foto12a,foto13a;
    public Image foto1b,foto2b,foto3b,foto4b,foto5b,foto6b,foto7b,foto8b,foto9b,foto10b,foto11b,foto12b,foto13b;
    public Image foto1c,foto2c,foto3c,foto4c,foto5c,foto6c,foto7c,foto8c,foto9c,foto10c,foto11c,foto12c,foto13c;


    public area_trabajo(){
        ImageIcon im = null;

        im = createImageIcon("/media/n1a.png"); foto1a=im.getImage();
        im = createImageIcon("/media/n1b.png"); foto1b=im.getImage();
        im = createImageIcon("/media/n1c.png"); foto1c=im.getImage();

        im = createImageIcon("/media/n2a.png"); foto2a=im.getImage();
        im = createImageIcon("/media/n2b.png"); foto2b=im.getImage();
        im = createImageIcon("/media/n2c.png"); foto2c=im.getImage();

        im = createImageIcon("/media/n3a.png"); foto3a=im.getImage();
        im = createImageIcon("/media/n3b.png"); foto3b=im.getImage();
        im = createImageIcon("/media/n3c.png"); foto3c=im.getImage();

        im = createImageIcon("/media/n4a.png"); foto4a=im.getImage();
        im = createImageIcon("/media/n4b.png"); foto4b=im.getImage();
        im = createImageIcon("/media/n4c.png"); foto4c=im.getImage();

        im = createImageIcon("/media/n5a.png"); foto5a=im.getImage();
        im = createImageIcon("/media/n5b.png"); foto5b=im.getImage();
        im = createImageIcon("/media/n5c.png"); foto5c=im.getImage();

        im = createImageIcon("/media/n6a.png"); foto6a=im.getImage();
        im = createImageIcon("/media/n6b.png"); foto6b=im.getImage();
        im = createImageIcon("/media/n6c.png"); foto6c=im.getImage();

        im = createImageIcon("/media/n7a.png"); foto7a=im.getImage();
        im = createImageIcon("/media/n7b.png"); foto7b=im.getImage();
        im = createImageIcon("/media/n7c.png"); foto7c=im.getImage();

        im = createImageIcon("/media/n8a.png"); foto8a=im.getImage();
        im = createImageIcon("/media/n8b.png"); foto8b=im.getImage();
        im = createImageIcon("/media/n8c.png"); foto8c=im.getImage();

        im = createImageIcon("/media/n9a.png"); foto9a=im.getImage();
        im = createImageIcon("/media/n9b.png"); foto9b=im.getImage();
        im = createImageIcon("/media/n9c.png"); foto9c=im.getImage();

        im = createImageIcon("/media/n10a.png"); foto10a=im.getImage();
        im = createImageIcon("/media/n10b.png"); foto10b=im.getImage();
        im = createImageIcon("/media/n10c.png"); foto10c=im.getImage();

        im = createImageIcon("/media/n11a.png"); foto11a=im.getImage();
        im = createImageIcon("/media/n11b.png"); foto11b=im.getImage();
        im = createImageIcon("/media/n11c.png"); foto11c=im.getImage();

        im = createImageIcon("/media/n12a.png"); foto12a=im.getImage();
        im = createImageIcon("/media/n12b.png"); foto12b=im.getImage();
        im = createImageIcon("/media/n12c.png"); foto12c=im.getImage();

        im = createImageIcon("/media/n13a.png"); foto13a=im.getImage();
        im = createImageIcon("/media/n13b.png"); foto13b=im.getImage();
        im = createImageIcon("/media/n13c.png"); foto13c=im.getImage();

        pri_nodo=null;
    }

    public int getAlto(){
        return this.getHeight();
    }

    public int getLargo(){
        return this.getWidth();
    }

    public void parar_nodo(Nodo n) {//se encarga de desconfigurar los nodos que se conecten a un nodo cuando este cambia
        //n.corriendo=false;
        Nodo aux_nodo=pri_nodo;
        while(aux_nodo!=null)
        {
            Conexion aux_conexion=aux_nodo.pri_conexion;
            while(aux_conexion!=null)
            {
                if(aux_conexion.destino==n)
                {

                    if(aux_nodo.tipo.compareTo("Tree")!=0&&
                       aux_nodo.tipo.compareTo("Domain")!=0&&
                       aux_nodo.tipo.compareTo("Graph")!=0&&
                       aux_nodo.tipo.compareTo("Radial")!=0&&
                       aux_nodo.tipo.compareTo("Table")!=0
                      )aux_nodo.corriendo=false;

                }
                aux_conexion=aux_conexion.sig_conexion;
            }
            aux_nodo=aux_nodo.sig_nodo;
        }
    }

    public void paint(Graphics g){
        g.setColor(new Color(150,150,150));
        g.fillRect(0,0,this.getWidth(),this.getHeight());
        Nodo aux_nodo=null;
        Conexion aux_conexion=null;

        if(conectando==1)
        {
            g.setColor(Color.black);
            g.drawLine(posX_raton,posY_raton,origen.cordenadaX,origen.cordenadaY);
        }
        //DIBUJAR INICIALMENTE LAS CONEXIONES
        aux_nodo=pri_nodo;
	while(aux_nodo!=null)
        {   
            aux_conexion=aux_nodo.pri_conexion;
            while(aux_conexion!=null)
            {
                g.setColor(Color.WHITE);
                g.drawLine(aux_conexion.destino.cordenadaX,aux_conexion.destino.cordenadaY,aux_nodo.cordenadaX,aux_nodo.cordenadaY);
                aux_conexion=aux_conexion.sig_conexion;
            }
            aux_nodo=aux_nodo.sig_nodo;
        }
        
        //DIBUJAR CADA UNO DE LOS NODOS
        aux_nodo=pri_nodo;
	while(aux_nodo!=null)
        {
            if(aux_nodo.tipo.compareTo("Crawler")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto1c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto1b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto1a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Database")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto2c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto2b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto2a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("TXT")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto3c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto3b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto3a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Links")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto4c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto4b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto4a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Page Rank")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto5c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto5b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto5a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("HITS")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto6c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto6b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto6a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Web Linker")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto7c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto7b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto7a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Dijkstra")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto8c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto8b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto8a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Graph")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto9c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto9b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto9a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Radial")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto10c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto10b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto10a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Domain")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto11c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto11b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto11a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Table")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto12c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto12b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto12a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }
            if(aux_nodo.tipo.compareTo("Tree")==0){
                if(aux_nodo.corriendo==true)   g.drawImage(foto13c, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else
                {
                if(aux_nodo.configurado==true) g.drawImage(foto13b, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                else                           g.drawImage(foto13a, aux_nodo.cordenadaX-25, aux_nodo.cordenadaY-25,50,50, this);
                }
            }

            aux_nodo=aux_nodo.sig_nodo;
        }
        
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }

    public void eliminar_nodo(Nodo nod){
        //ELIMINAR ENLACES A ESTE NODO
        Nodo aux_nodo=null;
        Conexion aux_conexion=null;

        aux_nodo=pri_nodo;
        while(aux_nodo!=null)
        {
            aux_conexion=aux_nodo.pri_conexion;
            while(aux_conexion!=null)
            {
                if(aux_conexion.destino.id_nodo==nod.id_nodo)
                {
                    //eliminar esta conexion
                    if(aux_conexion==aux_nodo.pri_conexion)//es la primera
                    {
                            aux_nodo.pri_conexion=aux_nodo.pri_conexion.sig_conexion;
                            if(aux_nodo.pri_conexion!=null) aux_nodo.pri_conexion.ant_conexion=null;
                    }
                    else
                    {
                        if(aux_conexion==aux_nodo.ult_conexion)//es la ultima
                        {
                            aux_nodo.ult_conexion=aux_nodo.ult_conexion.ant_conexion;
                            aux_nodo.ult_conexion.sig_conexion=null;
                        }
                        else//esta en medio
                        {
                            aux_conexion.sig_conexion.ant_conexion=aux_conexion.ant_conexion;
                            aux_conexion.ant_conexion.sig_conexion=aux_conexion.sig_conexion;
                        }
                    }
                    aux_conexion=aux_nodo.pri_conexion;
                }
                else
                {
                    aux_conexion=aux_conexion.sig_conexion;
                }
            }
            aux_nodo=aux_nodo.sig_nodo;
        }
        //ELIMINAR NODO
        if(nod.id_nodo==pri_nodo.id_nodo)//es la primera
        {
                pri_nodo=pri_nodo.sig_nodo;
                if(pri_nodo!=null) pri_nodo.ant_nodo=null;
        }
        else
        {
            if(nod.id_nodo==ult_nodo.id_nodo)//es la ultima
            {
                ult_nodo=ult_nodo.ant_nodo;
                ult_nodo.sig_nodo=null;
            }
            else//esta en medio
            {
                nod.ant_nodo.sig_nodo=nod.sig_nodo;
                nod.sig_nodo.ant_nodo=nod.ant_nodo;
            }
        }
    }

    public void insertar_nodo(String tipo,int pos_x,int pos_y){
        Nodo nue_nodo=null;
        nue_nodo=new Nodo(tipo,pos_x,pos_y);
        
        if(pri_nodo==null)
        {
            nue_nodo.id_nodo=1;
            pri_nodo=nue_nodo;
            ult_nodo=nue_nodo;
	}
        else
	{
	    nue_nodo.id_nodo=ult_nodo.id_nodo+1;
            ult_nodo.sig_nodo=nue_nodo;
            nue_nodo.ant_nodo=ult_nodo;
            ult_nodo=nue_nodo;
	}
    }

    public void conectar(Nodo fuente,Nodo destino){
        Conexion nue_conexion=new Conexion(destino);
        if(fuente.pri_conexion==null)
        {
            fuente.pri_conexion=nue_conexion;
            fuente.ult_conexion=nue_conexion;
	}
        else
	{
            fuente.ult_conexion.sig_conexion=nue_conexion;
            nue_conexion.ant_conexion=fuente.ult_conexion;
            fuente.ult_conexion=nue_conexion;
	}        
    }

    public int revisar(Conexion c,String t){   //revisa si en las conexiones de un nodo existe un nodo tipo "t" configurado y arrancado
        //retorna 0 si no encuentra
        //1 si esta pero no configurado
        //2 se esta pero no corriendo
        //3 si esta configurado y arrancado
        Conexion aux_conexion=c;
        while(aux_conexion!=null)
        {
            if(aux_conexion.destino.tipo.compareTo(t)==0)
            {
                if(aux_conexion.destino.configurado==false) return 1;
                if(aux_conexion.destino.corriendo==false) return 2;
                encontrado=aux_conexion.destino;
                return 3;
            }
            aux_conexion=aux_conexion.sig_conexion;
        }
        encontrado=null;
        return 0;
    }

    private int conexionLinks(Nodo fuente,Nodo destino){
            if(fuente.pri_conexion!=null)
            {
                JOptionPane.showMessageDialog(null, "this node already has a Web Data Source", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            if(destino.tipo.compareTo("Crawler")==0)
            {
                if(destino.pri_conexion!=null)
                {
                    JOptionPane.showMessageDialog(null, "The crawler can have only one connection", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }
                else
                {
                    conectar(fuente,destino);
                    return 1;
                }
            }

            if(destino.tipo.compareTo("Database")==0)
            {
                if(destino.pri_conexion!=null)
                {
                    JOptionPane.showMessageDialog(null, "The Database node can have only one connection", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }
                else
                {
                    conectar(fuente,destino);
                    return 1;
                }
            }

            if(destino.tipo.compareTo("TXT")==0)
            {
                if(destino.pri_conexion!=null)
                {
                    JOptionPane.showMessageDialog(null, "The txt can have only one connection", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }
                else
                {
                    conectar(fuente,destino);
                    return 1;
                }
            }

            JOptionPane.showMessageDialog(null, "The destination node can not connect to a node type link", "Invalid connection", JOptionPane.ERROR_MESSAGE);
            return 0;
    }

    private int conexionGraph(Nodo fuente,Nodo destino){

        if(fuente.pri_conexion!=null)
        {
            if(fuente.pri_conexion.destino.tipo.compareTo("Links")==0)
            {
                JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            else
            {
                if(destino.tipo.compareTo("Links")==0)
                {
                    JOptionPane.showMessageDialog(null, "this node can only be connected to Page Rank, Hits or Web Linker node", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }

            }
        }

        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Graph node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionHits(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
            JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
            return 0;
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a  Hits node type", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionVisits(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
            JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
            return 0;
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a  Hits Node type", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionPageRank(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
            JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
            return 0;
        }
        if(destino.tipo.compareTo("Links")==0)
        {
                conectar(fuente,destino);
                return 1;
        }
        JOptionPane.showMessageDialog(null, "The destination node can not connect to a node type Page Rank", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionRadial(Nodo fuente,Nodo destino){
        
        if(fuente.pri_conexion!=null)
        {
            if(fuente.pri_conexion.destino.tipo.compareTo("Links")==0)
            {
                JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            else
            {
                if(destino.tipo.compareTo("Links")==0)
                {
                    JOptionPane.showMessageDialog(null, "this node can only be connected to Page Rank, Hits or Web Linker node", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }

            }
        }

        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Radial Node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionDomain(Nodo fuente,Nodo destino){
         if(fuente.pri_conexion!=null)
        {
            if(fuente.pri_conexion.destino.tipo.compareTo("Links")==0)
            {
                JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            else
            {
                if(destino.tipo.compareTo("Links")==0)
                {
                    JOptionPane.showMessageDialog(null, "this node can only be connected to Page Rank, Hits or Web Linker node", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }

            }
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Domain Node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionTable(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
            if(fuente.pri_conexion.destino.tipo.compareTo("Links")==0||fuente.pri_conexion.destino.tipo.compareTo("Dijkstra")==0)
            {
                JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            else
            {
                if(destino.tipo.compareTo("Links")==0||destino.tipo.compareTo("Dijkstra")==0)
                {
                    JOptionPane.showMessageDialog(null, "this node can only be connected to Page Rank, Hits or Web Linker node", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }
            }
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Dijkstra")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Table Node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionTree(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
            if(fuente.pri_conexion.destino.tipo.compareTo("Links")==0)
            {
                JOptionPane.showMessageDialog(null, "this node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
            }
            else
            {
                if(destino.tipo.compareTo("Links")==0)
                {
                    JOptionPane.showMessageDialog(null, "this node can only be connected to Page Rank, Hits or Web Linker node", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                    return 0;
                }

            }
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Tree Node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    private int conexionDijkstra(Nodo fuente,Nodo destino){
        if(fuente.pri_conexion!=null)
        {
                JOptionPane.showMessageDialog(null, "This node does not accept more connections", "Invalid connection", JOptionPane.ERROR_MESSAGE);
                return 0;
        }
        if(destino.tipo.compareTo("Links")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Page Rank")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("HITS")==0)
        {
            conectar(fuente,destino);
            return 1;
        }
        if(destino.tipo.compareTo("Web Linker")==0)
        {
            conectar(fuente,destino);
            return 1;
        }

        JOptionPane.showMessageDialog(null, "The destination node can not connect to a Dijkstra Node type ", "Invalid connection", JOptionPane.ERROR_MESSAGE);
        return 0;
    }

    public Nodo buscar(int id)
    {
        Nodo aux_nodo=pri_nodo;
        while(aux_nodo!=null)
        {
            if(aux_nodo.id_nodo==id) return aux_nodo;
            aux_nodo=aux_nodo.sig_nodo;
        }
        return null;
    }

    public int insertar_conexion(Nodo fuente,Nodo destino){
        if(fuente.tipo.compareTo("Links")==0) return conexionLinks(fuente,destino);
        if(fuente.tipo.compareTo("Graph")==0) return conexionGraph(fuente,destino);
        if(fuente.tipo.compareTo("Page Rank")==0) return conexionPageRank(fuente,destino);
        if(fuente.tipo.compareTo("HITS")==0) return conexionHits(fuente,destino);
        if(fuente.tipo.compareTo("Web Linker")==0) return conexionVisits(fuente,destino);
        if(fuente.tipo.compareTo("Radial")==0) return conexionRadial(fuente,destino);
        if(fuente.tipo.compareTo("Domain")==0) return conexionDomain(fuente,destino);
        if(fuente.tipo.compareTo("Table")==0) return conexionTable(fuente,destino);
        if(fuente.tipo.compareTo("Tree")==0) return conexionTree(fuente,destino);
        if(fuente.tipo.compareTo("Dijkstra")==0) return conexionDijkstra(fuente,destino);
        return 0;
    }
}
class lista_nodos
{
    Nodo pri_nodo;
    Nodo ult_nodo;
    Nodo apuntador;
    Nodo nue_nodo;

    public lista_nodos() {
    }

    public void incertar_nodo(Nodo nod){
        nue_nodo=new Nodo("ss",1,1);
        apuntador=nod;
        if(pri_nodo==null)
        {
            pri_nodo=nue_nodo;
            ult_nodo=nue_nodo;
        }
        else
        {
            ult_nodo.sig_nodo=nue_nodo;
            nue_nodo.ant_nodo=ult_nodo;
            ult_nodo=nue_nodo;
        }

    }

}
