//configurar graficos de actividad estadistica
package polaris3.Statistics.uaOS;

import polaris2.graph.Nodo;

public class ConfGraficoOS extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoConfigurado=false;
    
    static boolean serieHits=false;
    static boolean serieVisitantes=false;
    static boolean serieTransferencia=false;
    
    public ConfGraficoOS(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        
        //agrupar radio butons 2
        grupoBotones2.add(radioBtnHits);//opcion serie request (hist Y/0 paginas vistas)
        grupoBotones2.add(radioBtnVisitors);//opcion serie visitantes
        grupoBotones2.add(radioBtnTransferencia);//opcion serie transferencia
    }
    
    public void NodoConfigurado(){
        if(nodoConfigurado==true){
            n.configurado=true;//cambiar color de nodo a verde
            if(n.corriendo==true)
                n.corriendo=false;//si el nodo esta corriendo y es configurado nuevamenta pasa a verde
        }
    }
    
    private void SeriesGrafico(){
        //seleccionar las series del grafico con chekbox
        if(radioBtnHits.isSelected())
            serieHits=true;
        else
            serieHits=false;
        
        if(radioBtnVisitors.isSelected())
            serieVisitantes=true;
        else
            serieVisitantes=false;
        
        if(radioBtnTransferencia.isSelected())
            serieTransferencia=true;
        else
            serieTransferencia=false;
        
    }
    
    
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTransferencia: "+serieTransferencia);
        System.out.println("---------------------------------------------------");
    }
    
    

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        grupoBotones1 = new javax.swing.ButtonGroup();
        grupoBotones2 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        radioBtnHits = new javax.swing.JRadioButton();
        radioBtnVisitors = new javax.swing.JRadioButton();
        radioBtnTransferencia = new javax.swing.JRadioButton();
        btnAceptar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Settings");

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Series Chart", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        radioBtnHits.setSelected(true);
        radioBtnHits.setText("Hits");
        radioBtnHits.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnHitsFocusGained(evt);
            }
        });

        radioBtnVisitors.setText("Visitors");
        radioBtnVisitors.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnVisitorsFocusGained(evt);
            }
        });

        radioBtnTransferencia.setText("Data Transfer");
        radioBtnTransferencia.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnTransferenciaFocusGained(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(radioBtnTransferencia)
                    .addComponent(radioBtnVisitors)
                    .addComponent(radioBtnHits))
                .addContainerGap(255, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(radioBtnHits)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(radioBtnVisitors)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(radioBtnTransferencia))
        );

        btnAceptar.setText("Accept");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed(evt);
            }
        });

        btnCancelar.setText("Cancel");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(123, 123, 123)
                        .addComponent(btnAceptar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnCancelar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnCancelar)
                    .addComponent(btnAceptar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed
    //boton aceptar
    SeriesGrafico();
    ImprimirConfiguracion();
    nodoConfigurado=true;
    this.setVisible(false);
}//GEN-LAST:event_btnAceptarActionPerformed

private void radioBtnVisitorsFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnVisitorsFocusGained

}//GEN-LAST:event_radioBtnVisitorsFocusGained

private void radioBtnTransferenciaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnTransferenciaFocusGained

}//GEN-LAST:event_radioBtnTransferenciaFocusGained

private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
    this.setVisible(false);
    this.dispose();
}//GEN-LAST:event_btnCancelarActionPerformed

private void radioBtnHitsFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnHitsFocusGained

}//GEN-LAST:event_radioBtnHitsFocusGained


    public static boolean isSerieHits() {
        return serieHits;
    }

    public static boolean isSerieTransferencia() {
        return serieTransferencia;
    }

    public static boolean isSerieVisitantes() {
        return serieVisitantes;
    }
    
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoOS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoOS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoOS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoOS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                ConfGraficoOS dialog = new ConfGraficoOS(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JButton btnCancelar;
    private javax.swing.ButtonGroup grupoBotones1;
    private javax.swing.ButtonGroup grupoBotones2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton radioBtnHits;
    private javax.swing.JRadioButton radioBtnTransferencia;
    private javax.swing.JRadioButton radioBtnVisitors;
    // End of variables declaration//GEN-END:variables
}
