/**
 * ClassificationTableModel.java
 *
 * Created on 26 de mayo de 2007, 03:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package prePro;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class regLogTableModel extends AbstractTableModel {
    
     String[] columnNames = {   "#",
                                "HOSTREMOTO",
                                "USER",
                                "DATE",
                                "TYPE", // Duracion
                                "REQUEST",
                                "PROTOCOL", // Duracion
                                "STATUS",
                                "DOWNLOAD SIZE"};
        private ArrayList registros;
        protected TableModel model;

        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /**
     * Creates a new instance of regLogTableModel
     */
        public regLogTableModel(ArrayList regs) {
            registros= regs;
            fireTableChanged(null);
        }
        
        /** nicamente retornamos el numero de elementos del
         * array de los nombres de las columnas
         *
         */
        public int getColumnCount() {
            return columnNames.length;
        }

        /** retormanos el numero de elementos
         * del array de datos
         */
        public int getRowCount() {
            return registros.size();
        }

        /** retornamos el nombre de la columna de indice col
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        /** retornamos el indice de tal nombre de la columna
         */
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)){
                    salir=true; 
                    i--;
                }
            }
            indice=i;
            //
            return indice;
        }

        /*** Devuelve el objeto en tal fila tal columna
         */
        public Object getValueAt(int row, int col) {
            Object obj = registros.get(row);
            String dato="";
            switch(col){
                case 0:
                    dato= String.valueOf(row + 1);
                    break;
                case 1:
                    dato= ((regLog) obj).getHostremoto();
                    break;
                case 2:
                    dato= ((regLog) obj).getaUser();
                    break;
                case 3:
                    dato= ((regLog) obj).getFecha();
                    dato= dato + "  " + ((regLog) obj).getHora();
                    break;
                case 4:
                    dato= ((regLog) obj).getMetodo();
                    break;
                case 5:
                    dato= ((regLog) obj).getSolicitud();
                    break;
                case 6:
                    dato= ((regLog) obj).getProtocolo();
                    break;
                case 7:
                    dato= String.valueOf(((regLog) obj).getEstado());
                    break;
                case 8:
                    dato= String.valueOf(((regLog) obj).getBytes());
                    break;
                case 9:
                    dato= String.valueOf(((regLog) obj).getReferente());
                    break;
                case 10:
                    dato= String.valueOf(((regLog) obj).getNavegador());
                    break;
            }
            return dato;
        }
        
        /** Devuelve la sesion completa de tal fila
         */
        public regLog getSesionAt(int row){
            return (regLog) registros.get(row);
        }
        
        /** Devuelve los valores de toda una columna en un Vector 
         */
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<registros.size();i++){
                Object obj = registros.get(i);
                switch(col){
                    case 0:
                        dato= ((regLog) obj).getHostremoto();
                        break;
                    case 1:
                        dato= ((regLog) obj).getaUser();
                        break;
                    case 2:
                        dato= ((regLog) obj).getFecha();
                        dato= dato + "  " + ((regLog) obj).getHora();
                        break;
                    case 3:
                        dato= ((regLog) obj).getMetodo();
                        break;
                    case 4:
                        dato= ((regLog) obj).getSolicitud();
                        break;
                    case 5:
                        dato= ((regLog) obj).getProtocolo();
                        break;
                    case 6:
                        dato= String.valueOf(((regLog) obj).getEstado());
                        break;
                    case 7:
                        dato= String.valueOf(((regLog) obj).getBytes());
                        break;
                    case 8:
                        dato= String.valueOf(((regLog) obj).getReferente());
                        break;
                    case 9:
                        dato= String.valueOf(((regLog) obj).getNavegador());
                        break;
                }                
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /**
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(ArrayList datosnuevos) {
            this.registros = datosnuevos;
            
        }
        
        /** Coloca nuevos nombres a las columnas si es necesario
         */
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }
        
        
   
    
}
