/*
 * estadisticas.java
 *
 * Created on 5 de agosto de 2007, 09:56 PM
 */

package statistical;

import java.awt.Image;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import Utils.conexion;

/**
 *
 * @author  Administrador
 */
public class estadisticas extends javax.swing.JDialog {
    
    String logpath;
    conexion conx;
    ResultSet rS;
    ArrayList codigos,ncod;
    ArrayList dia,ndia;
    ArrayList pagina,npag;
    ArrayList cip,ncip;
    //
    int cont; // Cant de Regs
    String paraFechas; // Tanto la de inicio como la final
    
    /** Creates new form estadisticas */
    public estadisticas(String dirlog) {
        //super(parent, modal);        
        this.setIconImage(this.getImage("/media/appicon.png"));        
        initComponents();
        //
        this.setTitle("Statisticals of Log");
        logpath= dirlog;
        //System.out.println("dir1: " + dirlog);
        //System.out.println("dir2: " + logpath);
        fillGeneral();
    }
    
    /** Armar estadisticas generales */
    public void fillGeneral(){
        txt_log.setText(logpath);
        // * llenar con consultas de la BD
        // Instanciar conx
        conx= new conexion();
        // Abrir conexion a BD logs
        conx.conectar("polaris","upolaris","ppolaris");
        // 
        try{
	    rS= conx.consulta("SELECT count(*) FROM log");
            rS.next();
            cont = rS.getInt(1);	    	            
            txt_cont.setText(String.valueOf(cont));
            //System.out.println("cont: " + cont);
            //
            rS= conx.consulta("SELECT fecha, hora FROM log WHERE id=1");
            rS.next();
            paraFechas= rS.getString(1) + " " + rS.getString(2);
            txt_date.setText(paraFechas);
            //System.out.println("fini: " + paraFechas);
            //
            rS= conx.consulta("SELECT fecha, hora FROM log WHERE id=" + cont);
            rS.next();
            paraFechas= rS.getString(1) + " " + rS.getString(2);
            txt_datef.setText(paraFechas);
            //System.out.println("ffin: " + paraFechas);
            //
            rS= conx.consulta("SELECT sum(bytes) FROM log");
            rS.next();
            cont= rS.getInt(1);
            txt_byte.setText(String.valueOf(cont));
            //System.out.println("bytes: " + cont);
            //   
            this.getDatosCodigos();
            this.getDatosPag();
            this.getDatosIP();
            this.getDatosRef();
            this.getDatosDia();
            //
            conx.cerrarConexion();
    	}catch(SQLException e){
            System.out.println("Error: " + e.getMessage());   			    		
    	}
        
    }
    
    public void getDatosCodigos(){
        int cod,n,nm,mayor=0,i;
        //
        codigos= new ArrayList();
        ncod= new ArrayList();
        //
        rS= conx.consulta("SELECT distinct (estado) FROM log");
        try {
            while(rS.next()){
                n= rS.getInt(1);
                codigos.add(n);
            }
            nm=0; //System.out.println("CODIGOS");
            for(i=0;i<codigos.size();i++){
                cod= Integer.parseInt(codigos.get(i).toString()); //System.out.println("cod: " + cod );
                rS= conx.consulta("SELECT count(*) FROM log WHERE estado=" + cod);
                rS.next();
                n= rS.getInt(1); //System.out.println("cont: " + n);
                if(n>nm) { mayor= cod; nm=n; }
                ncod.add(n);
            }
            //
            if(mayor>0)txt_cod.setText(this.getNomCod(mayor));
            //System.out.println("cod: " + mayor);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }       
        //        
    }
    
    public String getNomCod(int mayor){
        String nom="";
        //
        switch(mayor){
            case 100: nom="Informational";
                break;
            case 200: nom="Successful";
                break;
            case 300: nom="Redirection";
                break;
            case 400: nom="Client Error";
                break;
            case 500: nom="Server Error";
                break;            
        }
        //
        //nom="Informational aaa";
        return String.valueOf(mayor) + " - " + nom;
    }
    
    public String getNomDay(int mayor){
        String nom="";
        //
        switch(mayor){
            case 0: nom="Sunday";
                break;
            case 1: nom="Monday";
                break;
            case 2: nom="Tuesday";
                break;
            case 3: nom="Wednesday";
                break;
            case 4: nom="Thursday";
                break;
            case 5: nom="Friday";
                break;            
            case 6: nom="Saturday";
                break;
        }
        //
        //nom="Informational aaa";
        return nom;
    }
    
    public void getDatosDia(){
        int cod,n,nm,mayor=0,i;
        //
        dia= new ArrayList();
        ndia= new ArrayList();
        //        
        try {
            for(i=0;i<7;i++){                
                dia.add(i);
            }
            nm=0; //System.out.println("dia");
            for(i=0;i<dia.size();i++){
                cod= Integer.parseInt(dia.get(i).toString()); //System.out.println("cod: " + cod );
                rS= conx.consulta("SELECT count(EXTRACT (DOW FROM fecha)) FROM log WHERE EXTRACT (DOW FROM fecha)=" + cod);
                if(rS!=null){
                    rS.next();
                    n= rS.getInt(1); //System.out.println("cont: " + n);
                    
                }else{
                    n=0;
                }
                
                if(n>nm) { mayor= cod; nm=n; }
                    ndia.add(n);
            }
            //
            if(mayor>0)txt_day.setText(this.getNomDay(mayor));
            //System.out.println("cod: " + mayor);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }       
        //        
    }
    
    public void getDatosPag(){
        int n,nm,i;
        String nomp,mayor="";
        //
        pagina= new ArrayList();
        npag= new ArrayList();
        //
        rS= conx.consulta("SELECT distinct (peticion) FROM log");
        try {
            while(rS.next()){
                nomp= rS.getString(1);
                pagina.add(nomp);
            }
            nm=0; //System.out.println("Paginas");
            for(i=0;i<pagina.size();i++){
                nomp= pagina.get(i).toString(); //System.out.println("cod: " + nomp );
                rS= conx.consulta("SELECT count(*) FROM log WHERE peticion='" + nomp + "'");
                rS.next();
                n= rS.getInt(1); //System.out.println("cont: " + n);
                if(n>nm) { mayor= nomp; nm=n; }
                npag.add(n);
            }
            //
            if(!mayor.equals(""))txt_pag.setText(mayor);
            //System.out.println("cod: " + mayor);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }       
        //        
    }
    
    public void getDatosRef(){
        int n,nm,i;
        String nomp,mayor="";
        //
        ArrayList ref= new ArrayList();        
        //
        rS= conx.consulta("SELECT distinct (referencia) FROM log");
        try {
            while(rS.next()){
                nomp= rS.getString(1);
                ref.add(nomp);
            }
            nm=0; //System.out.println("Referer");
            for(i=0;i<ref.size();i++){
                nomp= ref.get(i).toString(); //System.out.println("cod: " + nomp );
                rS= conx.consulta("SELECT count(*) FROM log WHERE referencia='" + nomp + "'");
                rS.next();
                n= rS.getInt(1); //System.out.println("cont: " + n);
                if(n>nm) { mayor= nomp; nm=n; }
            }
            //
            if(!mayor.equals(""))txt_ref.setText(mayor);
            if(mayor.equals("-"))txt_ref.setText("From other site");
            //System.out.println("cod: " + mayor);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }       
        //        
    }
    
    public void getDatosIP(){
        int n,nm,i;
        String nomp,mayor="";
        //
        cip= new ArrayList();        
        ncip= new ArrayList();        
        //
        rS= conx.consulta("SELECT distinct (hostremoto) FROM log");
        try {
            while(rS.next()){
                nomp= rS.getString(1);
                cip.add(nomp);
            }
            nm=0; //System.out.println("Host");
            for(i=0;i<cip.size();i++){
                nomp= cip.get(i).toString(); //System.out.println("cod: " + nomp );
                rS= conx.consulta("SELECT count(*) FROM log WHERE hostremoto='" + nomp + "'");
                rS.next();
                n= rS.getInt(1); //System.out.println("cont: " + n);
                if(n>nm) { mayor= nomp; nm=n; }
                ncip.add(n);
            }
            //
            if(!mayor.equals(""))txt_client.setText(mayor);
            //System.out.println("cod: " + mayor);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }       
        //        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        txt_log = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        txt_date = new javax.swing.JTextField();
        txt_datef = new javax.swing.JTextField();
        txt_byte = new javax.swing.JTextField();
        txt_pag = new javax.swing.JTextField();
        txt_client = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        lst_graf = new javax.swing.JComboBox();
        lst_graf1 = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        txt_ref = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        txt_cont = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        txt_cod = new javax.swing.JTextField();
        txt_day = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resource/nomstat.png"))); // NOI18N

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("General"));

        jLabel2.setText("Log File: ");

        txt_log.setEditable(false);

        jLabel3.setText("Start Date: ");

        jLabel4.setText("Final Date:");

        jLabel5.setText("Total of bytes sent: ");

        jLabel6.setText("Popular page download: ");

        jLabel7.setText("Popular client IP: ");

        txt_date.setEditable(false);

        txt_datef.setEditable(false);

        txt_byte.setEditable(false);

        txt_pag.setEditable(false);

        txt_client.setEditable(false);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Graphics"));

        lst_graf.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "State Codes", "The best download day", "Download Page", "Client IP" }));

        lst_graf1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BarChart", "PieChart", "LineChart" }));

        jButton1.setText("View");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel12.setText("Attribute:");

        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel13.setText("Type:");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lst_graf, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lst_graf1, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(46, 46, 46)
                .addComponent(jButton1)
                .addGap(62, 62, 62))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(lst_graf, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel12)
                .addComponent(jLabel13)
                .addComponent(lst_graf1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton1))
        );

        txt_ref.setEditable(false);

        jLabel8.setText("Popular referer: ");

        jLabel9.setText("Records Amount:");

        txt_cont.setEditable(false);

        jLabel10.setText("Popular State Cod:");

        txt_cod.setEditable(false);

        txt_day.setEditable(false);

        jLabel11.setText("Popular day:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 727, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel6)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel8))
                                .addGap(13, 13, 13))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(11, 11, 11)))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txt_client, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(135, 135, 135)
                                .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, 101, Short.MAX_VALUE)
                                .addGap(15, 15, 15)
                                .addComponent(txt_cod, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(67, 67, 67))
                            .addComponent(txt_pag, javax.swing.GroupLayout.DEFAULT_SIZE, 595, Short.MAX_VALUE)
                            .addComponent(txt_log, javax.swing.GroupLayout.DEFAULT_SIZE, 595, Short.MAX_VALUE)
                            .addComponent(txt_ref, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 595, Short.MAX_VALUE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(txt_date, javax.swing.GroupLayout.PREFERRED_SIZE, 254, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(16, 16, 16)
                                        .addComponent(jLabel4)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(txt_datef, javax.swing.GroupLayout.DEFAULT_SIZE, 269, Short.MAX_VALUE)
                                        .addGap(0, 0, 0))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(txt_byte, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(14, 14, 14)
                                        .addComponent(jLabel9)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(txt_cont, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(txt_day, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)))))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txt_log, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txt_date, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(txt_datef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txt_byte, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel5)
                        .addComponent(txt_cont, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel9))
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txt_day, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel11)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txt_pag, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(txt_ref, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txt_client, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(txt_cod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(69, 69, 69))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 759, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
        // *** Polaris *** Johana ***
        String tipoG= lst_graf.getSelectedItem().toString();
        String claseG= lst_graf1.getSelectedItem().toString();
        graficas mt= new graficas(tipoG, logpath);
        mt.setGrafico(claseG);
        if(tipoG.equals("State Codes")){
            mt.setDatos(codigos,ncod,"State Codes");
        }else if(tipoG.equals("The best download day")){            
            mt.setDatos(dia,ndia,"The best download day");
        }else if(tipoG.equals("Download Page")){
            mt.setDatos(pagina,npag,"Download Page");
        }else if(tipoG.equals("Client IP")){
            mt.setDatos(cip,ncip,"Client IP");
        }
        // centrar
        mt.setLocationRelativeTo(mt.getParent());
        // Visible
        mt.setVisible(true);                    
        // *** Finished ***
    }//GEN-LAST:event_jButton1ActionPerformed
    
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    
    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new estadisticas(new javax.swing.JFrame(), true).setVisible(true);
//            }
//        });
//    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JComboBox lst_graf;
    private javax.swing.JComboBox lst_graf1;
    private javax.swing.JTextField txt_byte;
    private javax.swing.JTextField txt_client;
    private javax.swing.JTextField txt_cod;
    private javax.swing.JTextField txt_cont;
    private javax.swing.JTextField txt_date;
    private javax.swing.JTextField txt_datef;
    private javax.swing.JTextField txt_day;
    private javax.swing.JTextField txt_log;
    private javax.swing.JTextField txt_pag;
    private javax.swing.JTextField txt_ref;
    // End of variables declaration//GEN-END:variables
    
}

