/**Configuracion del preproceso, formulario lanzado por umbral*/

package workspace.Prepro;

import java.awt.Color;
import java.awt.Image;
import javax.swing.ImageIcon;
import workspace.Main_Set.Main;

public class FrmGAP extends javax.swing.JDialog {      
      /**instanciacion de la clase UmbrallNode.java*/
      private UmbralNode u;
      /**configuraciones iniciales de este achivo*/
      public boolean ELF = true;
      public boolean MFR = false;
      public FrmGAP(java.awt.Frame parent, UmbralNode nodo) {
          super(parent, true);
          initComponents();
          this.setIconImage(this.getImage("/media/star.png"));
          /**la instanciacion u toma el valor de nodo*/
          u = nodo;  
          /**muestra el combo del tiempo y el valor seleccionado*/
          this.lst_tsesion.setSelectedItem(this.u.getTsesion());
          /**validacion para que el mfr aparezca marcado o no*/
          if (this.u.isMfr() == true){
            this.chkMfr.setSelected(true);
        } else {
            this.chkMfr.setSelected(false);
        }
      }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnCancel = new javax.swing.JButton();
        btnAccept = new javax.swing.JButton();
        lst_tsesion = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        chkMfr = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Umbral Session");
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnAccept.setText("Accept");
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        lst_tsesion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "30", "10", "20", "40", "50", "60" }));
        lst_tsesion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lst_tsesionActionPerformed(evt);
            }
        });

        jLabel2.setText("Minutes range:");

        chkMfr.setText("Is MFR");
        chkMfr.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        chkMfr.setEnabled(false);
        chkMfr.setMargin(new java.awt.Insets(0, 0, 0, 0));
        if (this.ELF == true) {
            chkMfr.setEnabled(true);
        }
        chkMfr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkMfrActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                .addComponent(lst_tsesion, javax.swing.GroupLayout.PREFERRED_SIZE, 152, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addComponent(btnAccept)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 58, Short.MAX_VALUE)
                .addComponent(btnCancel)
                .addGap(34, 34, 34))
            .addGroup(layout.createSequentialGroup()
                .addGap(87, 87, 87)
                .addComponent(chkMfr, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(99, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 22, Short.MAX_VALUE)
                    .addComponent(lst_tsesion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkMfr)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnAccept, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnCancel))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

/**manejo de conos ********************************************************/
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
/**manejo de conos ********************************************************/
    
    private void chkMfrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkMfrActionPerformed
        /**comprobacion de mfr*/
         if(this.chkMfr.isSelected() == true){ 
            this.MFR = true;                                      
        } else {
            this.MFR = false;                                
        } 
    }//GEN-LAST:event_chkMfrActionPerformed

    private void lst_tsesionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lst_tsesionActionPerformed
                
    }//GEN-LAST:event_lst_tsesionActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
        /**esta cadena retorna el rango seleccionado*/
        this.u.setExecuted(false);
        this.u.setTsesion(this.lst_tsesion.getSelectedItem().toString());        
        /**si el usuario hace clic en aceptar entonces el  nodo cambia la bandera*/
        /**configured a verdadero y hace que el*/
        /**borde del nodo se torne azul, toma el valor de la sesion en minutos; 
        * siempre que este sea difernte de ""             */
        if (this.u.getTsesion() != "Select a value") {
            /**el color del borde se hace azul*/
            this.u.setBorderColor(new Color(0,0,255));
            /**la bandera de configuracion se hace verdadera*/
            this.u.setConfigured(true);
            /**se compureba el mfr y se imprime*/
            if(this.MFR == true){                
                this.u.setMfr(true);  
                System.out.print(" Umbral form, the mfr value is: " + this.u.isMfr());
            } else {    
                this.u.setMfr(false);  
                System.out.print(" Umbral form, the mfr value is: " + this.u.isMfr());
            }               
            /**se muestra el valor de los minutos*/
            System.out.println(" Umbral form, the range's value is: " + this.u.getTsesion());
            /**la ventana desaparece*/
            this.setVisible(false);
        }
        /**pero si el  valor de la sesion es ""
        * el borde se torna negro y la bandera se hace falsa*/
        else {
            this.u.setTsesion("Select a value");
            this.u.setBorderColor(new Color(0,0,0));
        }                              
    }//GEN-LAST:event_btnAcceptActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
       
        this.setVisible(false);
        /**validacion para no cambiar los la configuracion cuando el nodo esta 
        * configurado o ejecutado y se oprime el boton cancelar*/
        if (this.u.isConfigured() == true) {
            this.u.setConfigured(true);
            this.u.setBorderColor(new Color(0,0,255));
            if (this.u.isExecuted() == true){
                this.u.setExecuted(true);
                this.u.setBorderColor(new Color(0,255,0));
            }
        }         
    }//GEN-LAST:event_btnCancelActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnCancel;
    private javax.swing.JCheckBox chkMfr;
    private javax.swing.JLabel jLabel2;
    public javax.swing.JComboBox lst_tsesion;
    // End of variables declaration//GEN-END:variables
    
}
