/**Configuracion del preproceso, formulario lanzado por interval*/

package workspace.Prepro;

import java.awt.Color;
import java.awt.Image;
import javax.swing.ImageIcon;
import workspace.Main_Set.Main;

public class FrmInterval extends javax.swing.JDialog {      
      /**instanciacion de la clase IntervalNode.java*/
      private IntervalNode iv;
      /**configuraciones iniciales de este achivo*/
      public boolean ELF = true;
      public boolean MFR = false;
      public FrmInterval(java.awt.Frame parent, IntervalNode nodo) {
          super(parent, true);
          initComponents();
          this.setIconImage(this.getImage("/media/star.png"));
          /**la instanciacion iv toma el valor de nodo*/
          iv = nodo;  
          /**muestra el combo del tiempo y el valor seleccionado*/
          this.lst_tsesion.setSelectedItem(this.iv.getTsesion());
          /**validacion para que el mfr aparezca marcado o no*/
          if (this.iv.isMfr() == true){
            this.chkMfr.setSelected(true);
        } else {
            this.chkMfr.setSelected(false);
        }
      }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnCancel = new javax.swing.JButton();
        btnAccept = new javax.swing.JButton();
        lst_tsesion = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        chkMfr = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Interval Session");
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnAccept.setText("Accept");
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        lst_tsesion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "30", "10", "20", "40", "50", "60" }));
        lst_tsesion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lst_tsesionActionPerformed(evt);
            }
        });

        jLabel2.setText("Minutes range:");

        chkMfr.setText("Is MFR");
        chkMfr.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        chkMfr.setEnabled(false);
        chkMfr.setMargin(new java.awt.Insets(0, 0, 0, 0));
        if (this.ELF == true) {
            chkMfr.setEnabled(true);
        }
        chkMfr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkMfrActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(jLabel2)
                        .addGap(14, 14, 14)
                        .addComponent(lst_tsesion, javax.swing.GroupLayout.PREFERRED_SIZE, 152, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addComponent(btnAccept)
                        .addGap(45, 45, 45)
                        .addComponent(btnCancel))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(89, 89, 89)
                        .addComponent(chkMfr, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 22, Short.MAX_VALUE)
                    .addComponent(lst_tsesion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkMfr)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnAccept, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnCancel))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

/**manejo de iconos *********************************************************/
            
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
/**manejo de iconos ********************************************************/
    
    private void chkMfrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkMfrActionPerformed
        /**configura el mfr, si esta seleccionado entonces el mfr es verdadero
        *en caso contrario es falso*/
        if(this.chkMfr.isSelected() == true){ 
            this.MFR = true;                                      
        } else {
            this.MFR = false;                                
        } 
    }//GEN-LAST:event_chkMfrActionPerformed

    private void lst_tsesionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lst_tsesionActionPerformed
         
    }//GEN-LAST:event_lst_tsesionActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
        /**esta cadena retorna el rango seleccionado*/
        this.iv.setExecuted(false);
        this.iv.setTsesion(this.lst_tsesion.getSelectedItem().toString());
        /**si el usuario hace clic en aceptar entonces el  nodo cambia la bandera configured a verdadero y hace que el
        *borde del nodo se torne azul, toma el valor de la sesion en minutos; siempre que este sea difernte de null*/                
        if (this.iv.getTsesion() != "Select a value") {
            /**el color del borde se hace azul*/
            this.iv.setBorderColor(new Color(0,0,255));
            /**la bandera de configuracion se hace verdadera*/
            this.iv.setConfigured(true);
             /**esta cadena retorna el rango seleccionado        */
            if(this.MFR == true){                
                this.iv.setMfr(true);  
                System.out.print(" Interval form, the mfr value is: " + this.iv.isMfr());
            } else {    
                this.iv.setMfr(false);  
                System.out.print(" Interval form, the mfr value is: " + this.iv.isMfr());
            }            
            /**se muestra el valor de los minutos*/
            System.out.println(" Interval form, the range's value is: " + this.iv.getTsesion());            
            /**la ventana desaparece*/
            this.setVisible(false);
        }
        /**pero si el  valor de la sesion es ""
        *el borde se torna negro y la bandera se hace falsa*/
        else {
            this.iv.setTsesion("Select a value");
            this.iv.setBorderColor(new Color(0,0,0));
        }
        
                      
    }//GEN-LAST:event_btnAcceptActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        /**la ventana se hace invisible y se valida, si el ya esta configurado
        *que continue configiurado y con borde azul, de lo contrario que 
        *mantega su estado como no configurado             
        
        *validacion para no cambiar los la configuracion cuando el nodo esta         
        *configurado o ejecutado y se oprime el boton cancelar*/
        this.setVisible(false);  
        if (this.iv.isConfigured() == true) {
            this.iv.setConfigured(true);
            this.iv.setBorderColor(new Color(0,0,255));
            if (this.iv.isExecuted() == true){
                this.iv.setExecuted(true);
                this.iv.setBorderColor(new Color(0,255,0));
            }
        }
    }//GEN-LAST:event_btnCancelActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnCancel;
    private javax.swing.JCheckBox chkMfr;
    private javax.swing.JLabel jLabel2;
    public javax.swing.JComboBox lst_tsesion;
    // End of variables declaration//GEN-END:variables
    
}
