/**
 * ClassificationTableModel.java
 *
 * Created on 26 de mayo de 2007, 03:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package workspace.Views;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class DataTableModel extends AbstractTableModel {
    
     String[] columnNames = {   "#",
                                "DATA"
                            };
        private Vector datos;
        protected TableModel model;
        
        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /**
     * Creates a new instance of regLogTableModel
     */
        public DataTableModel(Vector ses) {
            datos= ses;
            fireTableChanged(null);
        }
        
        /** nicamente retornamos el numero de elementos del
         * array de los nombres de las columnas
         *
         */
        public int getColumnCount() {
            return columnNames.length;
        }

        /** retormanos el numero de elementos
         * del array de datos
         */
        public int getRowCount() {
            return datos.size();
        }

        /** retornamos el nombre de la columna de indice col
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        /** retornamos el indice de tal nombre de la columna
         */
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)){
                    salir=true; 
                    i--;
                }
            }
            indice=i;
            //
            return indice;
        }

        /*** Devuelve el objeto en tal fila tal columna
         */
        public Object getValueAt(int row, int col) {
            Object obj = datos.get(row);
            String dato;
            //
            switch(col){
                case 0:
                    dato= String.valueOf(row + 1);
                    break;
                default:
                    dato= obj.toString();
                    break;   
            }            
            //
            return dato;
        }
        
        /** Devuelve la sesion completa de tal fila
         */
        public String getSesionAt(int row){
            return (String) datos.get(row);
        }
        
        /** Devuelve los valores de toda una columna en un Vector 
         */
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<datos.size();i++){
                Object obj = datos.get(i);                
                //
                switch(col){
                    case 0:
                        dato= String.valueOf(i + 1);
                        break;
                    default:
                        dato= obj.toString();
                        break;   
                }            
                //
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /**
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(Vector datosnuevos) {
            this.datos = datosnuevos;
            
        }
        
        /** Coloca nuevos nombres a las columnas si es necesario
         */
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }
        
         
}
