/*
 * texto3d.java
 *
 * Created on 3 de agosto de 2007, 01:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package about;

import java.awt.Font;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class texto3d {
    
    /** grupo de escena */
    private BranchGroup textoBG;
    
    /** Creates a new instance of texto3d */
    public texto3d() {
//       // Create the root of the branch graph
        textoBG = new BranchGroup();

        Transform3D t3D = new Transform3D();
        t3D.setTranslation(new Vector3f(0.0f, -0.9f, -3.0f));
        TransformGroup objMove = new TransformGroup(t3D);
        textoBG.addChild(objMove);

        // Create the transform group node and initialize it to the
        // identity. Add it to the root of the subgraph.
        TransformGroup objSpin = new TransformGroup();
        objSpin.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        objMove.addChild(objSpin);
        // Apariencia del texto
        Appearance textAppear = new Appearance();
        ColoringAttributes textColor = new ColoringAttributes();
        textColor.setColor(0.0f,0.0f,1.0f);
        textAppear.setColoringAttributes(textColor);
        textAppear.setMaterial(new Material());

        // Tipo de letra y texto 
        Font3D font3D = new Font3D(new Font("Helvetica", Font.PLAIN, 1),
            new FontExtrusion());
        Text3D textGeom = new Text3D(font3D, new String("Polaris"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        // Create a simple shape leaf node, add it to the scene graph.
        Shape3D textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        textShape.setAppearance(textAppear);
        objSpin.addChild(textShape);

        // Create a new Behavior object that will perform the desired
        // operation on the specified transform object and add it into
        // the scene graph.
        Alpha rotationAlpha = new Alpha(-1, 5000);

        RotationInterpolator rotator = new RotationInterpolator(rotationAlpha,
            objSpin);

        // a bounding sphere specifies a region a behavior is active
        // create a sphere centered at the origin with radius of 100
        BoundingSphere bounds = new BoundingSphere();
        rotator.setSchedulingBounds(bounds);
        objSpin.addChild(rotator);
        // Luz 
        DirectionalLight lightD = new DirectionalLight();
        lightD.setInfluencingBounds(bounds);
        lightD.setDirection(new Vector3f(0.0f, 0.0f, -1.0f));
        lightD.setColor(new Color3f(0.72f, 0.72f, 0.72f));
        objMove.addChild(lightD);
        // Ambiente de luz
        AmbientLight lightA = new AmbientLight();
        lightA.setInfluencingBounds(bounds);
        objMove.addChild(lightA);
    }
    
    /** devuelve un grupo grafico */
    public BranchGroup getBG(){
        return textoBG;
    }    
    
}// FIN CLASE
