/**
 * c45.java
 *
 * Created on 23 de junio de 2007, 05:29 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification.c45_1;

import algorithm.classification.ClassificationTableModel;
import algorithm.classification.clasesAtrib;
import algorithm.classification.elemento;
import java.util.ArrayList;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class c45 extends Thread {
    
    // ***
    String Target;
    elemento arbolDecision, def;
    build_decisionTree construir;
    ArrayList datos;
    ClassificationTableModel ejemplos; // La tabla de datos 
    ArrayList atributos;
    int indexT;
    clasesAtrib catrib;
    // ***
    
    /** Creates a new instance of c45 */
    public c45(ArrayList dat, String clase) {
        datos= dat;
        Target= clase;        
        ejemplos= new ClassificationTableModel(datos);
        //
        atributos= new ArrayList(7);
        for(int i=0;i<6;i++){
            if(!Target.equals(ejemplos.getColumnName(i)))
            atributos.add(ejemplos.getColumnName(i));
        }
        //
        indexT= ejemplos.getColumnIndex(Target);
    }
    
    public void colocarValores(ArrayList iduracion, ArrayList icantidad, ArrayList itamano){
        catrib= new clasesAtrib();
        if(iduracion==null){
            catrib.porDefectoD();
        }else{
            catrib.porIntervaloD(iduracion);
        }
        if(icantidad==null){
            catrib.porDefectoC();
        }else{
            catrib.porIntervaloC(icantidad);
        }
        if(itamano==null){
            catrib.porDefectoT();
        }else{
            catrib.porIntervaloT(itamano);
        }
    }
    
    /** Ejecuta la creacion de arbol de decision */
    public void ejecutar(){
        def= new elemento("No hubo Clasificacion");
        construir= new build_decisionTree(Target, indexT, catrib);
        arbolDecision= construir.decisionTree(ejemplos,atributos,def);
        
    }
    
    /** Devuelve el arbol de decision */
    public elemento getArbolDecision(){
        return arbolDecision;
    }
    
    /** Hace correr el hilo */
    public void run() {
        long time = System.currentTimeMillis();
        int count = 0;
        
        this.ejecutar();
        
        long executionTime = System.currentTimeMillis() - time;        
        
        System.out.println("C45 tiempo: " + executionTime);
    }
    
}
