/*
 * mate.java
 *
 * Created on 23 de junio de 2007, 05:29 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification.mate;

import algorithm.classification.ClassificationTableModel;
import algorithm.classification.clasesAtrib;
import algorithm.classification.elemento;
import java.util.ArrayList;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class mate extends Thread {
    
    // *** Entradas
    String Target;    
    ClassificationTableModel ejemplos; // La tabla de datos 
    // *** Proceso
    build_decisionTree construir;
    ArrayList atributos;
    int indexT;
    // *** Salidas
    elemento arbolDecision, def;
    clasesAtrib catrib;
    
    /**
     * Creates a new instance of mate
     */
    public mate(ArrayList datos, String clase) {        
        Target= clase;        
        ejemplos= new ClassificationTableModel(datos);
        //
        atributos= new ArrayList(7);
        for(int i=0;i<ejemplos.getColumnCount();i++){
            if(!Target.equals(ejemplos.getColumnName(i)))
            atributos.add(ejemplos.getColumnName(i));
        }
        //
        indexT= ejemplos.getColumnIndex(Target);
    }
    
    public void colocarValores(ArrayList iduracion, ArrayList icantidad, ArrayList itamano){
        catrib= new clasesAtrib();
        if(iduracion==null){
            catrib.porDefectoD();
        }else{
            catrib.porIntervaloD(iduracion);
        }
        if(icantidad==null){
            catrib.porDefectoC();
        }else{
            catrib.porIntervaloC(icantidad);
        }
        if(itamano==null){
            catrib.porDefectoT();
        }else{
            catrib.porIntervaloT(itamano);
        }
    }
    
    // **
    public void ejecutar(){
        def= new elemento("No hubo Clasificacion");
        construir= new build_decisionTree(Target, indexT, catrib);
        arbolDecision= construir.decisionTree(construir.getTablaMate(ejemplos,atributos),0,atributos,def);        
    }
    
    // Borrar
    public MateTableModel primerparte(){
        construir= new build_decisionTree(Target, indexT, catrib);
        return construir.getTablaMate(ejemplos,atributos);
    }
    
    /** Obtiene el arbol de decision */
    public elemento getArbolDecision(){
        return arbolDecision;
    }
    
    /** Corre el hilo */
    public void run() {
        long time = System.currentTimeMillis();
        int count = 0;
        //
        this.ejecutar();        
        //
        long executionTime = System.currentTimeMillis() - time;                       
        System.out.println("Mate tiempo: " + executionTime);
    }
    
}
