/**este archivo sirve para almacenar los metodos de Nodo*/

package grammar;

import algorithm.hpg.produccion;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class NodeUtils {
    
    public static Nodo searchNodo(List<Nodo> nodos, int id){
        for (int i = 0; i < nodos.size(); i++) {
            if(nodos.get(i).getId() == id) return nodos.get(i);
        }
        return null;
    }
    
    
    public static List<Nodo> constructTree(List<produccion> nodosj){
        List<Nodo> nodos = new ArrayList<Nodo>();
        for(int x = 0; x<nodosj.size();x++){
            
            produccion nj = nodosj.get(x);
            
            int id1 = nj.getId1();
            int id2 = nj.getId2();
            
            Nodo n1 = null;
            Nodo n2 = null;
            Nodo re = null;
            
            re = NodeUtils.searchNodo(nodos,id1);
            if(re == null){
                n1 = new Nodo(id1);
                nodos.add(n1);
            } else{
                n1 = re;
            }
            
            re = NodeUtils.searchNodo(nodos,id2);
            boolean adela;
            if(re == null){
                n2 = new Nodo(id2);
                nodos.add(n2);
                adela = true;
            } else{
                n2 = re;
                adela = false;
            }
            // aqui solo 2 decimales
            double numero= nj.getProb();
            double dn= Math.round(numero*Math.pow(10,2))/Math.pow(10,2);           
            
            n1.addHijo(n2, dn,adela);
        }
        return nodos;
    }            
}
