/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package polaris2.graph;

import polaris2.mining.HITS;
import polaris2.mining.PageRank;
import polaris2.site.pagina;
import polaris2.site.sitio;

/**
 *
 * @author santos
 */
public class configuracion {

    public boolean InternalInLinks;
    public boolean InternalOutLinks;
    public boolean ExternalInLinks;
    public boolean ExternalOutLinks;
    public int totalDataProcces;
    public String url;
    public int search_level;
    public int links_by_page;
    public String protocols;
    public String no_protocols;
    public String domains;
    public String no_domains;
    public double dampening;
    public int iterationsPageRank;
    public int iterationsHits;
    public sitio site;  //sitio para graficar(solo links necesarios)
    public sitio site2;//sitio para calcular (doblemente encadenado)
    public PageRank pague_rank;//contiene la informacion del pague rank claculado 
    public HITS hits;//contiene la informacion del HITS claculado
    public String ruta_txt;
    public String info_txt;
    public Nodo nodo_data_source;//me dice el nodo que contiene la fuente de datos
    public Nodo nodo_links;//me dice el nodo de tipo links al que esta asociado este nodo
    public Nodo nodo_session;
    public String[][] rutas_dijkstra;//me dice el nodo de tipo links al que esta asociado este nodo
    public int num_rutas_dijkstra;
    public String tipo_dijkstra;
    public pagina source;
    public pagina target;
    public String nom_crawler_db;
    //public String ruta_txt;

    


    public configuracion()
    {
        InternalInLinks=false;
        InternalOutLinks=false;
        ExternalInLinks=false;
        ExternalOutLinks=false;
        url="";
        search_level=2;
        links_by_page=10;
        protocols="http,https,ftp";
        no_protocols="";
        domains="co,com,edu,gov,gob,net,org,pro,us,info,int,jobs,mil,mobi,museum,name,ar,br,bo,cl,cn,cr,do,ec,es,eu,fm,fr,hn,mx,pe,py,ru,sv,tel,travel,tv,uy,ve";
        no_domains="";
        no_domains=no_domains+"af,ax,al,ad,ao,ai,aq,ag,an,am,aw,ac,au,at,az,as,ae,bs,bh,bd,bb,be,bz,bj,bm,by,ba,bw,bn,bg,bf,bi,bt,bu,ch,cv,cm,ca,cy,cc,cg,cd,ck,ci,cr,cu,cx,cf,cz,";
        no_domains=no_domains+"de,dk,dm,dz,dj,eg,er,ee,et,eh,fo,fi,fj,fk,fm,ga,gm,ge,gs,gh,gi,gd,gr,gl,gu,gt,gg,gn,gq,gw,gy,gb,ht,hk,hu,hr,in,id,ir,iq,ie,is,il,it,im,jm,jp,je,jo,";
        no_domains=no_domains+"jh,kz,ke,kg,ki,kw,ky,kh,km,kp,kr,kn,la,ls,lv,lb,lr,ly,li,lt,lu,lc,lk,mo,mk,mg,my,mw,mv,ml,mt,mp,ma,mh,mu,mr,md,mc,mn,me,ms,mz,mm,na,nr,np,ni,ne,ng,";
        no_domains=no_domains+"nu,nf,no,nc,nz,nl,om,pk,pw,ps,pa,pg,pn,pf,pl,pt,pr,pm,ph,qa,rw,ro,rs,re,sb,sm,sh,st,sn,sc,sl,sg,sy,so,sz,sd,se,sr,sj,sa,sk,si,su,th,tz,tj,tf,io,tl,";
        no_domains=no_domains+"tg,tk,to,tt,tn,tc,tm,tr,tv,td,tw,ua,ug,um,uz,uk,vu,va,vn,vg,vi,vc,wf,ws,ye,yu,zm,zw,za,aq,bv,cs,dd,gf,gr,mq,sj,zr";

        dampening=0.85;
        iterationsPageRank=70;
        iterationsHits=35;
        site=null;
        pague_rank=null;
        nodo_data_source=null;//me dice el nodo de tipo crawler al que esta asociado este nodo
        nodo_links=null;//me dice el nodo de tipo links al que esta asociado este nodo
        ruta_txt="";
        info_txt="";
        totalDataProcces=0;
        rutas_dijkstra=null;
        num_rutas_dijkstra=0;
        tipo_dijkstra="";
        
    }

}
