
package polaris3.DataAcces;
import java.io.*;
import polaris3.ReadLogs.AbrirLog;


public class CargarRegistros extends javax.swing.JDialog {

    int miFormato;
    int numeroLineas;
    File miArchivoLog;
    CrearTablaW3C miTablaW3C;
    CrearTablaCommonLF miTablaCommonLF;
    CrearTablaCommonLFExt miTablaCommonLFExt;
    
    public CargarRegistros(java.awt.Frame parent, boolean modal,int formato, int cantidadLineas,File miArchivo) {
        super(parent, modal);
        initComponents(); 
        setDefaultCloseOperation(0); //deshabilitar
        this.setLocationRelativeTo(null);//centrar
        
        miFormato=formato;
        numeroLineas=cantidadLineas;
        miArchivoLog=miArchivo;
        jLabel1.setText("Cargando archivo "+miArchivoLog.getName()+" ...");
        this.btnAceptar.setEnabled(false);
        this.jProgressBar1.setMaximum(numeroLineas);
        
        
        CargarRegistros();
        
        //System.out.println("Numro de lineas:" + numeroLineas);
    }


    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();
        lblRegistros = new javax.swing.JLabel();
        btnAceptar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

        jLabel1.setText("jLabel1");

        lblRegistros.setFont(new java.awt.Font("Tahoma", 2, 9));
        lblRegistros.setText("jLabel2");

        btnAceptar.setText("Aceptar");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jProgressBar1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                            .addComponent(lblRegistros, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 374, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(178, 178, 178)
                        .addComponent(btnAceptar)))
                .addContainerGap(19, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblRegistros)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnAceptar)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed
// TODO add your handling code here:
    this.setVisible(false);
}//GEN-LAST:event_btnAceptarActionPerformed

    public void CargarRegistros()
    {
        if(miFormato==1)
        {
            miTablaW3C=new CrearTablaW3C(miArchivoLog,this.getJProgresBar1(),numeroLineas, this.getlblRegistros(),this.getbtnAceptar());
            this.miTablaW3C.start();
        }      
        if(miFormato==2)
        {
            miTablaCommonLF=new CrearTablaCommonLF(miArchivoLog,this.getJProgresBar1(),numeroLineas, this.getlblRegistros(),this.getbtnAceptar());
            this.miTablaCommonLF.start();
        } 
        if(miFormato==3)
        {
            miTablaCommonLFExt=new CrearTablaCommonLFExt(miArchivoLog,this.getJProgresBar1(),numeroLineas, this.getlblRegistros(),this.getbtnAceptar());
            this.miTablaCommonLFExt.start();
        }
    }
    
    public Object getJProgresBar1()//Getter
    {
        return this.jProgressBar1;
    }
    
    public Object getlblRegistros()//Getter
    {
        return this.lblRegistros;
    }
    
    public Object getbtnAceptar()//Getter
    {
        return this.btnAceptar;
    }
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CargarRegistros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CargarRegistros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CargarRegistros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CargarRegistros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JLabel lblRegistros;
    // End of variables declaration//GEN-END:variables
}
