
package polaris3.DataAcces;

import java.sql.*;
import javax.swing.JOptionPane;

//clase para crear una conexion a la base de datos q pueda ser utilizada por todas las clases
public class MiConexion {
    
    public Connection conexion;
    String ip;//ip de donde se encuentra la bd o localhost
    String bd;//nombre de la base de datos
    String usuario;//usuario (postgres)
    String pass;//password
    
    public MiConexion()
    {
        this.ip="localhost";
        this.bd="polaris";
        this.usuario="upolaris";
        this.pass="ppolaris";

        if(conexion!=null)
                return;
        
        String miDriver = "org.postgresql.Driver"; // el nombre de nuestro driver Postgres.
        // String connectString = "jdbc:postgresql://localhost:5432/ropa/"; // aqui llamamos a la base de datos por defecto
                                                                            //para llamar a otra BD la cadena seria: "jdbc:postgresql://localhost:5432/nombreBD/"
        String connectString="jdbc:postgresql://"+ip+":5432/"+bd+"/";

        try
        {
            Class.forName(miDriver);
            conexion=DriverManager.getConnection(connectString,usuario,pass);
            System.out.println("Clase MiConexion: Conexion exitosa");
        }
        catch(Exception e)
        {
            //mensaje de error de conexio a la bd
            JOptionPane.showMessageDialog(null, "Error: "+e.getMessage(), "Error en la conexión",JOptionPane.ERROR_MESSAGE);
            //System.exit(0);//salgo del programa
        }
    }//fin contructor
    
    public Connection getConexion()
    {
           return conexion;
    }

    public Connection CerrarConexion() throws SQLException
    {
        conexion.close();
        conexion = null;
        return conexion;
    }
    
}
