//cargar graficois actividadestadistica
package polaris3.Statistics.ActividadEstadistica;

import polaris3.Chart.GraficoActividadHora;
import polaris3.Chart.GraficoActividadFecha;
import polaris3.Chart.GraficoActividadDia;
import javax.swing.JOptionPane;
import polaris2.graph.Nodo;

public class CargarGraficoAE {
    
    public Nodo n =null;
    boolean nodoCorriendo=true;
    
    ConfGraficoActFecha confGraficoAF;
    ConfGraficoActDia confGraficoAD;
    ConfGraficoActHora confGraficoAH;
    
    static boolean estadoConfGrafico=false;//verificar si yase configuro el graficio
    
    String nombreGrafico="";
    //nombredel grafico, para saber que grafico se ba a crear
    static boolean actividadFecha=false;
    static boolean actividadDia=false;
    static boolean actividadHora=false;
    
    public GraficoActividadFecha graficoFecha=null;
    public GraficoActividadDia graficoDia=null;
    public GraficoActividadHora graficoHora=null;
        
    public CargarGraficoAE(String nombreGrafico){
        this.nombreGrafico=nombreGrafico;
        CargarConfiguracion();
        if(estadoConfGrafico==true){
            CargarConfiguracion();
            IdentificarGrafico();
        }else{
            JOptionPane.showMessageDialog(null, "Configurar grafico", "Activity Statistics",JOptionPane.ERROR_MESSAGE);
        } 
        
    }
    
     public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    private void CargarConfiguracion(){//cargar configuracion del grafico  
        if(nombreGrafico.compareTo("actividad_fecha")==0)
            estadoConfGrafico=confGraficoAF.isEstadoConfigurarGrafico();
        if(nombreGrafico.compareTo("actividad_dia")==0)
            estadoConfGrafico=confGraficoAD.isEstadoConfigurarGrafico();
        if(nombreGrafico.compareTo("actividad_hora")==0)
            estadoConfGrafico=confGraficoAH.isEstadoConfigurarGrafico();
    }
    
    private void IdentificarGrafico(){
        //identificar si es grafico actividad fecha, actividad dia o actividad diaria
        if(nombreGrafico.compareTo("actividad_fecha")==0)
            graficoFecha = new GraficoActividadFecha(null, false);
        if(nombreGrafico.compareTo("actividad_dia")==0)
            graficoDia = new GraficoActividadDia(null, false);
        if(nombreGrafico.compareTo("actividad_hora")==0)
            graficoHora = new GraficoActividadHora(null, false);
        nodoCorriendo=true;
    }
    
}
