
package polaris3.Statistics.RefBuscadores;

import polaris3.Statistics.EstadisticaAccesos.*;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;

public class CrearEstadisticasBuscadores {
    
    public Nodo n=null;
    boolean nodoCorriendo;
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    public CrearEstadisticasBuscadores(){
        CrearTablas();
        nodoCorriendo=true;
    }
    
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    private void CrearTablas(){//crear tabla en la bd
        //crea las siguientes tablas
        //Acceso_estadisticas
	//Acceso_extensiones
	//Acceso_tipoarchivo

        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_referentes_estadisticas() ");
            
            System.out.println("Se ejecuto la funcion crear_referentes_estadisticas() (). CrearEstadisticasBuscadores.java"); 
 
            miResulSet.close();
            miStatement.close();
        }
        catch (Exception e){
            System.out.println("Error al ejecutar lafuncion crear_referentes_estadisticas() (). CrearEstadisticasBuscadores.java");
            System.out.println(e.getMessage());
        }
        
         miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_est_buscadores() ");
            
            System.out.println("Se ejecuto la funcion crear_est_buscadores() (). CrearEstadisticasBuscadores.java"); 
 
            miResulSet.close();
            miStatement.close();
        }
        catch (Exception e){
            System.out.println("Error al ejecutar lafuncion crear_est_buscadores() (). CrearEstadisticasBuscadores.java");
            System.out.println(e.getMessage());
        }
    }
    
}
