/*
 * leerIIS.java
 *
 * Created on 6 de agosto de 2007, 06:41 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package prePro;

import Utils.conexion;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class leerIIS {
    
    private FileReader archivo;
    private BufferedReader entrada;
    private char tipoArchivo;
    private long numRegs;
    private String nombreArchivoLog;        
    private boolean finFichero;
    conexion conx;
    confpre config;
    private int tipoLog;   
    String probfecha;
    //
    String msj="";
    
    /** Creates a new instance of leerIIS */
    public leerIIS(String ruta) {
        probfecha="";
    	tipoArchivo='n';
    	numRegs=0;
    	finFichero=false;
    	try{
    		archivo=new FileReader(ruta);
    		entrada=new BufferedReader(archivo);    		
    		nombreArchivoLog=ruta;
    		config = new confpre();
                tipoLog=0;                
    		 		
    	}catch(Exception e){
    		System.out.println((new StringBuilder()).append("ERROR: La ruta o archivo no existen: ").append(e).toString());
                msj= (new StringBuilder()).append("ERROR: File doesn't exist: ").append(e).toString();
    	}
    	
    }
    
    public char gettipoArchivo(){
    	return tipoArchivo;
    }
    
    public long getnumRegs(){
    	return numRegs;    		
    }
    
    public String getnombreArchivoLog(){
    	return nombreArchivoLog;
    }
    
    /** Lectura del archivo log */
    public void leyendoLog() {
        String errorins="";
        regLog leer;
        String reglog;
        String elemento;
        String comPeticion;
        boolean comprobarExt;
        int totalreg, totalerror;
        // Crear tabla o etcetera
        // Instanciar conx
    	conx= new conexion();
    	// Abrir conexion a BD logs
    	conx.conectar("polaris","upolaris","ppolaris");
    	// Eliminar datos de tabla     	
    	conx.non_query("TRUNCATE TABLE log");
    	conx.non_query("ALTER SEQUENCE log_id_seq RESTART WITH 1");
        // listo para grabar
        totalerror=0;
        totalreg= 0;
        elemento="hostremoto, auser, fecha, hora, metodo, peticion, protocolo, estado, bytes, referencia, agenteu";
        comprobarExt=true;
        do{
        	leer = leerRegLog();
        	// Insetar log        				
        	if(finFichero==false){
        		//System.out.println("tipo: " + tipoArchivo);			
        		if(tipoArchivo!='n'){
	        		// Verificar si la extension es valida
	        		comPeticion = leer.getSolicitud().trim();
	        		comprobarExt = verificarExt(comPeticion);
	        		if(comprobarExt){
	        			try{
                                            // creamos un query
                                            reglog= "'" + leer.getHostremoto() + "', '" + leer.getaUser() + "', '" + leer.getFecha() + "', '" + leer.getHora() + "', '" + leer.getMetodo() + "', '" + leer.getSolicitud() + "', '" + leer.getProtocolo() + "', " + leer.getEstado() + ", " + leer.getBytes() + ", '" + leer.getReferente() + "', '" + leer.getNavegador() + "'";		
						//System.out.println(reglog);			
						if(conx!=null) { 
							errorins= conx.insertar("log",elemento, reglog );
                                                        if(errorins.equals("date/time field value out of range: '03-23-2007'")){
                                                            leer.putFecha(probfecha);
                                                            reglog= "'" + leer.getHostremoto() + "', '" + leer.getaUser() + "', '" + leer.getFecha() + "', '" + leer.getHora() + "', '" + leer.getMetodo() + "', '" + leer.getSolicitud() + "', '" + leer.getProtocolo() + "', " + leer.getEstado() + ", " + leer.getBytes() + ", '" + leer.getReferente() + "', '" + leer.getNavegador() + "'";		
                                                            errorins= conx.insertar("log",elemento, reglog );
                                                        }
							totalreg++;
						}	
                                        }catch(Exception e){
                                            System.out.println("no pudo");
                                            totalerror++;
                                        }
	        		}
                                else{
                                    totalerror++;
                                }
	        		
        		}
                        else{
                            System.out.println("ERROR");
                            totalerror++;
                        }
        		
        	}
			
        	// Termino        	
        }while(finFichero==false);
        //Cerrar conexion
        
        // listo
        if (finFichero) {
            try {            	
                entrada.close();
                archivo.close();                
                conx.cerrarConexion();
                msj= totalreg + " records are saved...";// but " + totalerror + " records didn't save";
            }
            catch (IOException ioex) {
                System.out.println("Error al cerrar el archivo");                
                msj= "Error: File couldn't close...";
            }
        
        } 
    }

	public boolean verificarExt(String pet){
		boolean valida=false;
		int extOk;		
		int ini, fin;
		String extension;
		//		
		extOk=0;
		for(int i=0;i<30 && valida==false;i++){
    		extOk= config.getExtnum(i);
    		if(extOk==1){
    			extension= config.getExtnom(i);
    			//
    			valida=pet.endsWith("." + extension);
    			if(extension.equals("txt")) {
    				if(pet.endsWith("robots.txt")) valida=false;
    			}
    		}
    	}
		
		//
		return valida;
	}
	
	// Colocar extensiones validas
	public  void ExtValidas(int[] indices, int total){
    	config.extensionesValidas(indices,total);
    }
        
   public int getTipoLog(){
       System.out.println("t: " + tipoLog);
       return tipoLog;
   }


    private regLog leerRegLog() {
		regLog regActual = null;
		String linea;
                boolean primerTipo=false;
		//   
		linea="nada";
		try{
			linea = entrada.readLine();				
		}catch(IOException ex){
			System.out.println("Error al leer linea del archivo");
		}
		
		if(linea==null) {
			 finFichero=true; 
			 regActual=null;
		}
		else{
			tipoArchivo='a';	
                        regActual = getRegLog(linea);	        
                        if(primerTipo==false && tipoArchivo!='n'){
                            if(tipoArchivo=='i') tipoLog=3;
                            //System.out.println("tipoArchivo primero: " + tipoLog);
                            primerTipo=true;
                        }                        
		}	     
        //
        numRegs++;       		        
        return regActual;
   }
   
   // 192.168.114.201, -, 03/20/01, 7:55:20, W3SVC2, SERVER, 172.21.13.45, 4502, 163, 3223, 200, 0, GET, /DeptLogo.gif, -, 
   // saca los atributos da la clase reglog
   private regLog getRegLog(String reg){
   	int posicionIni = 0; 
        regLog registroActual = null;        
        int posicionFin = reg.indexOf(',');
        //
        //System.out.println("**** Registro ****");
        String remoteHost = getRemoteHost(reg, posicionIni, posicionFin);
        //System.out.println("HostRemoto: " + remoteHost);
        if (remoteHost == null) {
            tipoArchivo = 'n';
        } else {
            posicionIni = posicionFin + 2;
            posicionFin = reg.indexOf(',', posicionIni);
            String auser = getAuthuser(reg, posicionIni, posicionFin);
                //System.out.println("Auser: " + auser);                
                if (auser == null) {
                    tipoArchivo = 'n';
        	} else {  
                    posicionIni = posicionFin + 2;
                    posicionFin = reg.indexOf(',', posicionIni);
                    String fecha[] = getFecha(reg, posicionIni, posicionFin);
                    probfecha= fecha[1];
                    //
                    if(fecha == null){
                        tipoArchivo= 'n';
                    }else{
                        posicionIni = posicionFin + 2;
                        posicionFin = reg.indexOf(',', posicionIni);
                        String hora = getHora(reg, posicionIni, posicionFin);
                        //
                        if(hora == null){
                            tipoArchivo= 'n';
                        }else{
                            posicionIni = posicionFin + 2;
                            posicionFin = reg.indexOf(',', posicionIni);
                            if(getComprobar(reg, posicionIni, posicionFin) == null){
                                tipoArchivo= 'n';
                            }else{
                                posicionIni = posicionFin + 2;
                                posicionFin = reg.indexOf(',', posicionIni);
                                if(getComprobar(reg, posicionIni, posicionFin) == null){
                                    tipoArchivo= 'n';
                                }else{
                                    posicionIni = posicionFin + 2;
                                    posicionFin = reg.indexOf(',', posicionIni);
                                    if(getComprobar(reg, posicionIni, posicionFin) == null){
                                        tipoArchivo= 'n';
                                    }else{
                                        posicionIni = posicionFin + 2;
                                        posicionFin = reg.indexOf(',', posicionIni);
                                        if(getComprobar(reg, posicionIni, posicionFin) == null){
                                            tipoArchivo= 'n';
                                        }else{
                                            posicionIni = posicionFin + 2;
                                            posicionFin = reg.indexOf(',', posicionIni);
                                            if(getComprobar(reg, posicionIni, posicionFin) == null){
                                                tipoArchivo= 'n';
                                            }else{
                                                posicionIni = posicionFin + 2;
                                                posicionFin = reg.indexOf(',', posicionIni);
                                                int bytes = getBytes(reg, posicionIni, posicionFin);
                                                if(bytes==-1){
                                                    tipoArchivo= 'n';
                                                }else{
                                                    posicionIni = posicionFin + 2;
                                                    posicionFin = reg.indexOf(',', posicionIni);
                                                    int estado = getEstado(reg, posicionIni, posicionFin);
                                                    if(estado == -1){
                                                        tipoArchivo='n';
                                                    }else{
                                                        posicionIni = posicionFin + 2;
                                                        posicionFin = reg.indexOf(',', posicionIni);
                                                        if(getComprobar(reg, posicionIni, posicionFin) == null){
                                                            tipoArchivo= 'n';
                                                        }else{
                                                            posicionIni = posicionFin + 2;
                                                            posicionFin = reg.indexOf(',', posicionIni);
                                                            String metodo = getMetodo(reg, posicionIni, posicionFin);
                                                            if(metodo == null){
                                                                tipoArchivo= 'n';
                                                            }else{
                                                                posicionIni = posicionFin + 2;
                                                                posicionFin = reg.indexOf(',', posicionIni);
                                                                String solicitud = getSolicitud(reg, posicionIni, posicionFin);
                                                                if(solicitud == null){
                                                                    tipoArchivo= 'n';
                                                                }else{
                                                                    registroActual = new regLog();
                                                                    registroActual.putHostRemoto(remoteHost);
                                                                    registroActual.putAuser(auser);
                                                                    registroActual.putFecha(fecha[0]);
                                                                    registroActual.putHora(hora);
                                                                    registroActual.putMetodo(metodo);
                                                                    registroActual.putSolicitud(solicitud);
                                                                    registroActual.putProtocolo("-");
                                                                    registroActual.putEstado(estado);
                                                                    registroActual.putBytes(bytes);
                                                                    tipoArchivo= 'i';
                                                                }
                                                            }
                                                        }
                                                    }
                                                }    
                                                
                                            }
                                        }
                                }
                            }    
                        }
                    }
                }                 
            }
        }
        return registroActual;
   }
   
   // Obtener elementos
   private String getRemoteHost(String s, int posicionIni, int posicionFin) {
        String salida;
		if (posicionFin == -1) {
            salida = null;
        } else {
            salida = s.substring(posicionIni, posicionFin);
        }
        return salida;
    }

    private String getRemoteUser(String s, int posicionIni, int posicionFin) {
        String salida;
        if (posicionFin == -1) {
            salida = null;
		} else {
            salida = s.substring(posicionIni, posicionFin);
        }
        return salida;
    }

    private String getAuthuser(String s, int posicionIni, int posicionFin) {
        String salida;
        if (posicionFin == -1) {
            salida = null;
        } else {
            salida = s.substring(posicionIni, posicionFin);
        }
        salida.trim();
        return salida;
    }

    /**
     * @deprecated Method getFecha is deprecated
     */

    private String[] getFecha(String s, int posicionIni, int posicionFin) {
        String mifecha, mes="", dia="", ano="";
        String salida[]= new String[2];
        int posini, posfin;
        //
        if (posicionFin == -1) {
            mifecha = null;
        } else {
            mifecha = s.substring(posicionIni, posicionFin);    
            //System.out.println("fecha: " + mifecha);
            //
            posini=0; posfin= mifecha.indexOf('/');
            mes= mifecha.substring(posini,posfin);
            //System.out.println("fecha: " + mes);
            //
            posini=posfin + 1; posfin= mifecha.indexOf('/',posini);
            dia= mifecha.substring(posini,posfin);
            //System.out.println("fecha: " + dia);
            //
            posini=posfin + 1;
            ano= mifecha.substring(posini);
            //System.out.println("fecha: " + ano);
            //
            salida[0]= dia + "-" + mes + "-" + ano;
            salida[1]= mes + "-" + dia + "-" + ano;
        }        
        //System.out.println("fecha: " + mifecha);        
        return salida;
    }

    /**
     * @deprecated Method getHora is deprecated
     */

    private String getHora(String s, int posicionIni, int posicionFin) {
        String mihora;
        if (posicionFin == -1) {
            mihora = null;
        } else {
            String salida = s.substring(posicionIni, posicionFin);
            mihora=salida;
        }
        return mihora;
    }

    private String getSolicitud(String s, int posicionIni, int posicionFin) {
        String salida;
/* 538*/        if (posicionFin == -1) {
/* 539*/            salida = null;
        } else {
/* 541*/            salida = s.substring(posicionIni, posicionFin);
        }
/* 543*/        return salida;
    }
    
    private String getMetodo(String s, int posicionIni, int posicionFin) {
        String salida;
/* 538*/        if (posicionFin == -1) {
/* 539*/            salida = null;
        } else {
/* 541*/            salida = s.substring(posicionIni, posicionFin);
        }
/* 543*/        return salida;
    }
    
    private String getProtocolo(String s, int posicionIni, int posicionFin) {
        String salida;
/* 538*/        if (posicionFin == -1) {
/* 539*/            salida = null;
        } else {
/* 541*/            salida = s.substring(posicionIni, posicionFin);
        }
/* 543*/        return salida;
    }

    private int getEstado(String s, int posicionIni, int posicionFin) {
        int salida;
/* 559*/        if (posicionFin == -1) {
/* 560*/            salida = -1;
        } else {
/* 563*/            String cadena = s.substring(posicionIni, posicionFin);
/* 567*/            try {
/* 567*/                Integer aux = new Integer(cadena);
/* 568*/                salida = aux.intValue();/* 570*/                
                }catch (NumberFormatException e) {
                salida = -1;
            }
        }
        return salida;
    }

    private int getBytes(String s, int posicionIni, int posicionFin) {        
        int salida;
        if (posicionFin == -1) {
            salida= -1;
        } else {            
            String cadena = s.substring(posicionIni, posicionFin);
            try {
                Integer aux = new Integer(cadena);
                salida = aux.intValue();
            }
            catch (NumberFormatException e) {
                salida = -1;
            }
        }
        return salida;
    }

    private String getComprobar(String s, int posicionIni, int posicionFin) {
        String si;
        if (posicionFin == -1) {
            si = null;
        } else {
            si = s.substring(posicionIni, posicionFin);            
        }
        return si;
    }
    
    /** Manda los mensajes de proceso */
    public String getMensaje(){
        return msj;
    }
        
}
