/**
 * @(#)transSesion.java
 *
 *
 * @author Proyecto *** Polaris *** Johana ***
 * @version 1.00 2007/3/13
 */

package prePro;

import Utils.conexion;
import java.sql.ResultSet;
import java.util.Vector;



public class transSesionExtendida {
	
	// Propiedades
	confpre config;
	conexion conx;
	ResultSet rS;
	int contReglog;
	SesionExtendida rSesion;
	Vector Sabiertas;
	// Variables Globales
	int indiceSabiertas;	
	boolean Sabierta, isMFR;
	String extVal;
        int timesesion;
        //
        String msj="";
        //

	/** Constructor */
    public transSesionExtendida(boolean mfr) {
    	
    	//inicializo conexion con BDLog
    	// Instanciar conx
    	conx= new conexion();
    	// Abrir conexion a BD logs
    	conx.conectar("polaris","upolaris","ppolaris");
    	// instanciar configuracion
    	config = new confpre();
    	//--
    	contReglog=0;
    	Sabierta=true;
    	Sabiertas = new Vector();
    	//
    	extVal="";
    	indiceSabiertas=0;
        timesesion=30;
    	//
    	// Eliminar datos de tabla 
    	// no esta haciendo el truncate
    	conx.non_query("TRUNCATE TABLE sesionextendida");
        conx.non_query("ALTER SEQUENCE sesionextendida_id_seq RESTART WITH 1");
    	//
        isMFR= mfr;
    }
    
    public void setMFR(boolean esmfr){
        isMFR= esmfr;
    }
    
    public boolean getMFR(){
        return isMFR;
    }
    
    /** Contar registros log */
    public void ContarReglog(){
    	int cont=0;
    	try{
	    	rS= conx.consulta("SELECT count(*) FROM log");
    	rS.next();
    	cont = rS.getInt(1);
	    	
    	}catch(Exception e){
			System.out.println("Error: " + e.getMessage());   			    		
    	}
    	
    	contReglog = cont;
    }
    
    public  int getcontarReglog(){
    	return contReglog;
}

	// Colocar extensiones validas
	public  void ExtValidas(int[] indices, int total){
    	config.extensionesValidas(indices,total);
    }
        
    public void setTiempoSesion(int t){
        timesesion = t;
    }
    
    public int getTiempoSesion(){
        return timesesion;
    }
    
    /** Leer registro log */
    public regLog LeerReglog(int index){
    	regLog rta;
    	int extOk=0;
    	String extension = "", pet= "";
    	boolean valida;
    	//
    	valida= false;
    	extVal = "";
    	try{
    		rS= conx.consulta("SELECT * FROM log WHERE id=" + index);  
    		rS.next();
    		pet= rS.getString("peticion");
    		for(int i=0;i<30 && valida==false;i++){
	    		extOk= config.getExtnum(i);
	    		if(extOk==1){
	    			extension= config.getExtnom(i);
	    			//
	    			valida=pet.endsWith("." + extension);	 	    			
	    		}
	    	}
    		
    		if(valida==true){
    			extVal=extension;
    			// guardar en rta
		    	rta = new regLog();
		    	rta.putHostRemoto(rS.getString("hostremoto"));
		    	rta.putAuser(rS.getString("auser"));
		    	rta.putFecha(rS.getString("fecha"));
		    	rta.putHora(rS.getString("hora"));
		    	rta.putMetodo(rS.getString("metodo"));
		    	rta.putSolicitud(rS.getString("peticion"));
		    	rta.putProtocolo(rS.getString("protocolo"));
		    	rta.putEstado(rS.getInt("estado"));
		    	rta.putBytes(rS.getLong("bytes"));
		    	rta.putReferente(rS.getString("referencia"));
		    	rta.putNavegador(rS.getString("agenteu"));
                        rta.putIDpag(rS.getInt("idpeticion"));
    		} else{
    			rta = null;
    			extVal="";
    		}
	    	
	    	
    	}catch(Exception e){
			System.out.println("Error: " + e.getMessage());   			    		
			rta = null;
    	}
    	
    	return rta;
    }   
    
    /** Crear sesion Umbral */
    public void crearSesionesUmbral(){
    	int  i,j,indSactual=0;
    	regLog rabierto;
    	java.util.Date fechareg;
    	java.util.Date fechaSfin;
    	SesionExtendida rSesionActual;
    	boolean pasoP;
    	// contar cuantos registros tiene el log
        int totalsesion=0;
    	contReglog=0;
    	ContarReglog();
    	// leer registro por registro
    	for(i=1;i<=contReglog;i++){
    		// leo un registro
    		
    		rabierto=LeerReglog(i);    		
    			
    		//System.out.println("registro No: " + i);
    		
    		// compruebo si hay elementos en Sesiones abiertas	
    		if(rabierto!=null){    		
    			// obtengo total de sesiones abiertas
    			//System.out.println("registro pet: " + rabierto.getSolicitud());
				indiceSabiertas=Sabiertas.size();
				Sabierta=false;
				// busco IP del reg abierto en las sesiones abiertas
				for(j=0;j<indiceSabiertas && Sabierta==false;j++){
					rSesion=(SesionExtendida) Sabiertas.elementAt(j);		
					if(rabierto.getHostremoto().equals(rSesion.getHostremoto())){
						// encontre IPen sesion abierta
                                                if(rabierto.getNavegador().equals(rSesion.getAgenteuser())){
							// encontre Agenteu en sesion abierta
							Sabierta=true;
							indSactual = j;
						}						
//						Sabierta=true;
//						indSactual = j;
					}
				}
    			// Si encontro IP
    			if(Sabierta){
    				// preguntar si el tiempo transcurrido es mayor a 30 minutos
    				//System.out.println("fechareg : " + rabierto.getFecha() + "horareg : " + rabierto.getHora() );
    				fechareg = Guardarfecha(rabierto.getFecha(), rabierto.getHora()); // -- Guardar fecha    
    				//System.out.println("fechareg1: " + fechareg);    					
    				rSesionActual=(SesionExtendida) Sabiertas.elementAt(indSactual);
    				fechaSfin = rSesionActual.getFechafin();
    				//
    				boolean mayor=false;
    				if(fechaSfin.getTime()>fechareg.getTime()) mayor=true;
    				//
    				pasoP= false;
    				if(mayor==false) { 
    					//System.out.println("fechainicio1: " + fechaSini);    					
    					pasoP= pasoPeriodo(fechaSfin,fechareg);
    				} else{
    					//System.out.println("fechainicio2: " + fechareg);
    					pasoP= pasoPeriodo(fechareg,fechaSfin);
    				}
    				// Condicion
    				if(pasoP==false){ // si no pasaron 30 minutos
    					// Actualizar la informacion de rsesionactual con los datos de rabierto
    					// colocar fechafin
    					if(mayor==false) { 
	    					rSesionActual.putFechahorafin(fechareg);
	    				} else{
	    					rSesionActual.putFechahorafin(fechaSfin);
	    					rSesionActual.putFechahorainicio(fechareg);
	    				}    					
    					// Aderir una solicitud
						rSesionActual.addNumSolicitudes();
						// Subir Bytes
						rSesionActual.addTotalbytes(rabierto.getBytes());
						// Tipos de ficheros
						rSesionActual.addTipoFichero(extVal);
                                                // IDPaginas Visitadas
                                                rSesionActual.addIDPag(rabierto.getIDpag());
						// Paginas Visitadas
						rSesionActual.addNomPagvisitadas(rabierto.getSolicitud());
                                                // Referencia Visitada
						rSesionActual.addNomPagReferencia(rabierto.getReferente());
						// Aderir
						Sabiertas.removeElementAt(indSactual);
						Sabiertas.insertElementAt(rSesionActual,indSactual);
						
						//
    					
    				}else{ // pasaron mas de 30 minutos
    					// Eliminar sesionactual de sabiertas
    					Sabiertas.removeElementAt(indSactual);
    					// insertar sesion cerrada
    					guardarSesionCerrada(rSesionActual);
                                        totalsesion++;
    					// Crear una nueva sesion
    					addSesionAbierta(rabierto);    					 
   					}
    				    				
    			} // No encontro IP
    			else{
    				// crear una nueva sesion abierta
    				//System.out.println("Entro");
    				addSesionAbierta(rabierto);
    				
    			}    	
    		}
    		//System.out.println("registro No: " + i);	
    	}
    	
    	if(i>contReglog){
    		//System.out.println(Sabiertas.size());
    		for(i=0;i<Sabiertas.size();i++){
    		    rSesionActual=null;		
	    		rSesionActual=(SesionExtendida) Sabiertas.elementAt(i);
	    		//Sabiertas.removeElementAt(indSactual);
				guardarSesionCerrada(rSesionActual);
                                totalsesion++;
    		}
    	}
    	//
        msj= totalsesion + " comun sessions are saved...";
    }
     
    /** Crear Sesion Intervalo */
    public void crearSesionesIntervalo(){
    	int  i,j,indSactual=0;
    	regLog rabierto;
    	java.util.Date fechareg;
    	java.util.Date fechaSini;
    	SesionExtendida rSesionActual;
    	boolean pasoP;
    	// contar cuantos registros tiene el log
        int totalsesion=0;
    	contReglog=0;
    	ContarReglog();
    	// leer registro por registro
    	for(i=1;i<=contReglog;i++){
    		// leo un registro
    		
    		rabierto=LeerReglog(i);    		
    			
    		//System.out.println("registro No: " + i);
    		
    		// compruebo si hay elementos en Sesiones abiertas	
    		if(rabierto!=null){    		
    			// obtengo total de sesiones abiertas
    			//System.out.println("registro pet: " + rabierto.getSolicitud());
				indiceSabiertas=Sabiertas.size();
				Sabierta=false;
				// busco IP y agenteusuario del reg abierto en las sesiones abiertas
				for(j=0;j<indiceSabiertas && Sabierta==false;j++){
					rSesion=(SesionExtendida) Sabiertas.elementAt(j);		
					if(rabierto.getHostremoto().equals(rSesion.getHostremoto())){
						// encontre IPen sesion abierta
						if(rabierto.getNavegador().equals(rSesion.getAgenteuser())){
							// encontre Agenteu en sesion abierta
							Sabierta=true;
							indSactual = j;
						}						
					}
				}
    			// Si encontro IP y agenteuser
    			if(Sabierta){
    				// preguntar si el tiempo transcurrido es mayor a 30 minutos
    				//System.out.println("fechareg : " + rabierto.getFecha() + "horareg : " + rabierto.getHora() );
    				fechareg = Guardarfecha(rabierto.getFecha(), rabierto.getHora()); // -- Guardar fecha    
    				//System.out.println("fechareg1: " + fechareg);    					
    				rSesionActual=(SesionExtendida) Sabiertas.elementAt(indSactual);
    				fechaSini = rSesionActual.getFechainicio();
    				//
    				boolean mayor=false;
    				if(fechaSini.getTime()>fechareg.getTime()) mayor=true;
    				//
    				pasoP= false;
    				if(mayor==false) { 
    					//System.out.println("fechainicio1: " + fechaSini);    					
    					pasoP= pasoPeriodo(fechaSini,fechareg);
    				} else{
    					//System.out.println("fechainicio2: " + fechareg);
    					pasoP= pasoPeriodo(fechareg,fechaSini);
    				}
    				// Condicion
    				if(pasoP==false){ // si no pasaron 30 minutos
    					// Actualizar la informacion de rsesionactual con los datos de rabierto
    					// colocar fechafin
    					if(mayor==false) { 
	    					rSesionActual.putFechahorafin(fechareg);
	    				} else{
	    					rSesionActual.putFechahorafin(fechaSini);
	    					rSesionActual.putFechahorainicio(fechareg);
	    				}    					
    					// Aderir una solicitud
						rSesionActual.addNumSolicitudes();
						// Subir Bytes
						rSesionActual.addTotalbytes(rabierto.getBytes());
						// Tipos de ficheros
						rSesionActual.addTipoFichero(extVal);
                                                // IDPaginas Visitadas
                                                rSesionActual.addIDPag(rabierto.getIDpag());
						// Paginas Visitadas
						rSesionActual.addNomPagvisitadas(rabierto.getSolicitud());
						// Referencia Visitada
						rSesionActual.addNomPagReferencia(rabierto.getReferente());
						// Aderir
						Sabiertas.removeElementAt(indSactual);
						Sabiertas.insertElementAt(rSesionActual,indSactual);
						
						//
    					
    				}else{ // pasaron mas de 30 minutos
    				
    					// Eliminar sesionactual de sabiertas
    					Sabiertas.removeElementAt(indSactual);
    					// insertar sesion cerrada
    					guardarSesionCerrada(rSesionActual);
                                        totalsesion++;
    					// Crear una nueva sesion
    					addSesionAbierta(rabierto);    					 
    				}
    				    				
    			} // No encontro IP
    			else{
    				// crear una nueva sesion abierta
    				//System.out.println("Entro");
    				addSesionAbierta(rabierto);
    				
    			}    	
    		}
    		//System.out.println("registro No: " + i);	
    	}
    	
    	if(i>contReglog){
    		//System.out.println(Sabiertas.size());
    		for(i=0;i<Sabiertas.size();i++){
    		    rSesionActual=null;		   		    	
	    		rSesionActual=(SesionExtendida) Sabiertas.elementAt(i);
	    		
	    		//Sabiertas.removeElementAt(i);
				guardarSesionCerrada(rSesionActual);
                                totalsesion++;
    		}
    	}
    	//
        msj= totalsesion + " comun sessions are saved...";
    }
    
    public void addSesionAbierta(regLog regAbierto){
    	String hostSesion;    	
    	String agenteu;
    	String fechainicio;
    	String horainicio;
    	java.util.Date fechaHora;
    	//
    	rSesion = null;
		rSesion = new SesionExtendida();
		// ingresar primeros datos
		rSesion.putHostremoto(regAbierto.getHostremoto()); // Host Remoto
		rSesion.putAgenteuser(regAbierto.getNavegador()); // Agente User
		// Fecha Hora inicio
		fechainicio = regAbierto.getFecha();
		horainicio = regAbierto.getHora();
		//System.out.println("fechainicio: " + fechainicio);
		//System.out.println("horainicio: " + horainicio);
		fechaHora = Guardarfecha(fechainicio, horainicio); 
		//System.out.println("FechaHora: " + fechaHora.toString());
		// -- Guardar fecha    				
		rSesion.putFechahorainicio(fechaHora);
		rSesion.putFechahorafin(fechaHora);
		// Aderir una solicitud
		rSesion.addNumSolicitudes();
		// Subir Bytes
		rSesion.addTotalbytes(regAbierto.getBytes());
		// Tipos de ficheros
		rSesion.addTipoFichero(extVal);
                // IDPaginas Visitadas
                rSesion.addIDPag(regAbierto.getIDpag());
		// Paginas Visitadas
		rSesion.addNomPagvisitadas(regAbierto.getSolicitud());
		// Pagina Referencia
		rSesion.addNomPagReferencia(regAbierto.getReferente());
		//
		//System.out.println("Host de la Sesion: " + rSesion.getHostremoto());
		//
		Sabiertas.addElement(rSesion);
    }
    
    public void guardarSesionCerrada(SesionExtendida rSesionActual){
    	// Moverlo a la base de datos
    	String nomtiposExt = rSesionActual.getNomtipofichero();    	
		String canttiposExt = rSesionActual.getTipofichero();
                String idpagVisitadas = rSesionActual.getIDPag();
		String nompagVisitadas = rSesionActual.getNompagvisitadas();
		//String cantpagVisitadas = rSesionActual.getPagvisitadas();
		String nompagReferencias = rSesionActual.getNompagReferencia();
		
		// HACER MFR AQUI
		String transacciones = rSesionActual.doTransacciones(isMFR);
		//System.out.println("Trans: " + transacciones);
    	
    	// Fecha inicio y fin
    	String fechaaux = 	rSesionActual.getFechainicio().toString();
    	String fechainicio = getFechaP(fechaaux);
    	fechaaux = 	rSesionActual.getFechafin().toString();
    	String fechafin = getFechaP(fechaaux);
    	//
    	//System.out.println("Fecha inicio: " + fechainicio);
		
		//conx.insertar("metadatos","",);
		String elementos = "hostremoto,agenteu,fechahorainicio,fechahorafin,numsolicitudes,totalbytes,nomtipofichero,tiposficheros,nompagvisitadas,transacciones";
		String regsesion = "'" + rSesionActual.getHostremoto() + "','" + rSesionActual.getAgenteuser() + "','" + fechainicio + "','" + fechafin + "'";
		regsesion = regsesion + "," + rSesionActual.getNumSolicitudes() + "," + rSesionActual.getTotalbytes() + "," + nomtiposExt + "," + rSesionActual.getTipofichero();
		regsesion = regsesion + "," + idpagVisitadas + "," + transacciones; 
		conx.insertar("sesionextendida",elementos,regsesion);
		
    }
        
    public boolean pasoPeriodo(java.util.Date fechaini, java.util.Date fechar){
    	long linicio;
    	long lreg;
    	long diferencia;
    	boolean tiempoMayor;
    	//
		tiempoMayor= false;
		linicio = fechaini.getTime();
		lreg = fechar.getTime();		
		
		//System.out.println("Antes: " + linicio + " Ahora: " + lreg + " Dif: " + (lreg - linicio)); 
		
		diferencia = lreg - linicio;
		//if(diferencia<0) diferencia = diferencia * -1;
		long hora = diferencia / 3600000;
		long restohora= diferencia % 3600000;
		long  minuto = restohora / 60000;
		long restomin = restohora % 60000;
		long segundo = (restomin/1000) + 1;		
		
		//System.out.println(hora + ":" + minuto + ":" + segundo);
		
		minuto = minuto + (hora*60);
		String min = minuto + "." + segundo;
		float minutos = Float.parseFloat(min);
				
		//System.out.println(minutos);
		
		if(minutos>timesesion) {
			tiempoMayor = true;
		}else{
			tiempoMayor = false;
		}
		
		return  tiempoMayor;
    }
    
    public java.util.Date Guardarfecha(String fechap, String horap) {    	
    	String ano, dia, mes;
    	int ini,fin;
    	
    	try{
    		ini=0;
    		fin=fechap.indexOf('-');
    		ano=fechap.substring(ini,fin);
    		//System.out.println(ano);
    		ini=fin+1;
    		fin=fechap.indexOf('-',ini+1);
    		mes=fechap.substring(ini,fin);
    		//System.out.println(mes);
    		ini=fin+1;    		
    		dia=fechap.substring(ini);
    		//System.out.println(dia);
    		String stodate = mes + "/" + dia + "/" + ano + " " + horap;
			java.text.SimpleDateFormat targetDateFormat = new java.text.SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
			java.util.Date d = targetDateFormat.parse(stodate);			
			//System.out.println(d.toString());	
			return d;
    	}catch(Exception e){
    		return null;
    	}    	
    }

	 private String getFechaP(String fechaj) {
        String mifecha;
        int ini,fin;
        //
        ini=0;
        fin=fechaj.indexOf(' ',ini);
        if (fin == -1) {
            mifecha = null;
        } else {
        	ini=fin+1;
        	fin=fechaj.indexOf(' ',ini);
            String mes = fechaj.substring(ini, fin);
            ini=fin+1;
        	fin=fechaj.indexOf(' ',ini);
            String dia = fechaj.substring(ini, fin);
            ini=fin+1;
        	fin=fechaj.indexOf(' ',ini);
            String hora = fechaj.substring(ini, fin);
            ini=fin+1; fin=fechaj.indexOf(' ',ini);
        	ini=fin+1; //fin=fechaj.indexOf(' ',ini);
            String ano = fechaj.substring(ini);
            if(mes.equals("Jan")){
            	mes="01";
            }else if(mes.equals("Feb")){
            	mes="02";
            }else if(mes.equals("Mar")){
            	mes="03";
            }else if(mes.equals("Apr")){
            	mes="04";
            }else if(mes.equals("May")){
            	mes="05";
            }else if(mes.equals("Jun")){
            	mes="06";
            }else if(mes.equals("Jul")){
            	mes="07";
            }else if(mes.equals("Aug")){
            	mes="08";
            }else if(mes.equals("Sep")){
            	mes="09";
            }else if(mes.equals("Oct")){
            	mes="10";
            }else if(mes.equals("Nov")){
            	mes="11";
            }else if(mes.equals("Dec")){
            	mes="12";
            }                        
            mifecha = ano + "-" + mes + "-" + dia + " " + hora;
        }
        return mifecha;
    }
    
    // Cerrar objetos usados como BD
    public void finalizar(){
    	conx.cerrarConexion();
    }
 
    public String getMensaje(){
        return msj;
    }
    
}