/*
 * graficas.java
 *
 * Created on 6 de agosto de 2007, 08:59 AM
 */

package statistical;

import grammar.colocarnom;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Image;
import java.awt.Paint;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import org.jfree.chart.*;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.chart.title.TextTitle;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.general.DefaultPieDataset;
import org.jfree.data.general.PieDataset;
import org.jfree.ui.GradientPaintTransformType;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.StandardGradientPaintTransformer;
import org.jfree.util.Rotation;

/**
 *
 * @author  Administrador
 */
public class graficas extends javax.swing.JDialog {
    
    ArrayList nomdatos, ndatos;
    BufferedImage grafica = null;
    ImageIcon imagen;
    String tituloG, tituloX, tituloY;
    String nomgraf;
    String Seleccion;
    boolean poner;
    //pnl_graf pgraf;
    private Paint[] colors;
    //
    private DefaultListModel model;    
    ArrayList npags;
    //
    
    /** Constructor (Que atributo, nombre del Archivo) */
    public graficas(String seleccion, String logfile){
        initComponents();
        this.setIconImage(this.getImage("/media/appicon.png"));
        lbl_state.setText(lbl_state.getText() + ": " + seleccion);
        this.setTitle("Polaris Statistical Grafics: " + seleccion + " Of LogFile: " + logfile);
        poner=false;
        //
        Seleccion= seleccion;
        lbl_nom.setText(Seleccion + ": ");
        //
    }
    
    /** Que tipo de Grafico: Barras, Pastel o Lineal */    
    public void setGrafico(String nomg){
        nomgraf=nomg;
    }
    
    /** Obtiene la informacion a graficar */
    public void setDatos(ArrayList nomdatos, ArrayList ndatos, String tit){
        this.nomdatos= nomdatos;
        this.ndatos= ndatos; 
        //
        lstNodos.setVisible(true);
        /** modelo del JList lstNodos*/
        model = new DefaultListModel();            
        String nodito;
        //
        tituloG= tit;
        tituloX= "x";
        tituloY= "y";
        if(tituloG.equals("State Codes")){
            tituloX= "Code";
            tituloY= "Quantity";
            //            
            int numero;
            /** el identificador de cada nodo es anadido */        
            for (int i = 0; i < nomdatos.size(); i++) {
                if(i<10){ 
                    numero= Integer.parseInt(nomdatos.get(i).toString());
                    nodito= numero + "  :: " + verEstado(numero) + " - TOTAL: " + ndatos.get(i).toString();                    
                }
                else{ 
                    numero= Integer.parseInt(nomdatos.get(i).toString());
                    nodito= numero + "  :: " + verEstado(numero) + " - TOTAL: " + ndatos.get(i).toString();
                }
                model.addElement(nodito);                
            }        
            this.lstNodos.setModel(model);        
            //
        }else
        if(tituloG.equals("The best download day")){
            tituloX= "Day";
            tituloY= "Quantity";   
            //            
            this.jScrollPane1.setVisible(false);
            this.lbl_nom.setVisible(false);
            //
        }else
        if(tituloG.equals("Download Page")){
            tituloX= "Page";
            tituloY= "Quantity";       
            //                        
            /** el identificador de cada nodo es anadido */        
            for (int i = 0; i < nomdatos.size(); i++) {
                if(i<10){ nodito= String.valueOf(i) + "   :: " + nomdatos.get(i).toString()  + " - TOTAL: " + ndatos.get(i).toString(); }
                else{ nodito= String.valueOf(i) + "  :: " + nomdatos.get(i).toString()  + " - TOTAL: " + ndatos.get(i).toString(); }
                model.addElement(nodito);                
            }        
            this.lstNodos.setModel(model);        
            //
        }
        if(tituloG.equals("Client IP")){
            tituloX= "IP o HostRemoto";
            tituloY= "Quantity";            
            //                        
            /** el identificador de cada nodo es anadido */        
            for (int i = 0; i < nomdatos.size(); i++) {
                if(i<10){ nodito= String.valueOf(i) + "   :: " + nomdatos.get(i).toString()  + " - TOTAL: " + ndatos.get(i).toString(); }
                else{ nodito= String.valueOf(i) + "  :: " + nomdatos.get(i).toString()  + " - TOTAL: " + ndatos.get(i).toString(); }
                model.addElement(nodito);                
            }        
            this.lstNodos.setModel(model);        
            //
        }
        //lbl_graf.setIcon(new javax.swing.ImageIcon());
        if(nomgraf.equals("BarChart")){
            imagen= new ImageIcon(this.creaImagenBarras());
        }else if(nomgraf.equals("PieChart")){
            if(nomdatos.size()<21) poner=true;
            if(nomdatos.size()<100) imagen= new ImageIcon(this.creaImagenPastel(this.createPieDataset()));            
            else lbl_state.setText("Pie Chart type is not legible with " + nomdatos.size() + " - Please, choose other type.");
        }else if(nomgraf.equals("LineChart")){
            imagen= new ImageIcon(this.creaImagenLine());
        }        
        lbl_graf.setIcon(imagen);
    }
    
    String verEstado(int num){
        String nom="";
        switch(num){
            case 100: nom="Informational";
                break;
            case 200: nom="Successful";
                break;
            case 300: nom="Redirection";
                break;
            case 400: nom="Client Error";
                break;
            case 500: nom="Server Error";
                break;            
        }
        //
        return nom;
    }
    
    String getNomDay(int mayor){
        String nom="";
        //
        switch(mayor){
            case 0: nom="Sunday";
                break;
            case 1: nom="Monday";
                break;
            case 2: nom="Tuesday";
                break;
            case 3: nom="Wednesday";
                break;
            case 4: nom="Thursday";
                break;
            case 5: nom="Friday";
                break;            
            case 6: nom="Saturday";
                break;
        }
        //
        //nom="Informational aaa";
        return nom;
    }
  
    /** GRAFICA DE BARRAS */
    public BufferedImage creaImagenBarras(){   
        //
        CategoryDataset dataset = createDataset();         
        JFreeChart chart = ChartFactory.createBarChart(tituloG,
                tituloX,tituloY,dataset,PlotOrientation.VERTICAL,
                false,
                true,
                 false                // Mostrar leyenda
                );
        //
        TextTitle title = chart.getTitle();
        title.setBorder(0, 0, 1, 0);
        title.setBackgroundPaint(new GradientPaint(0f, 0f, Color.BLUE, 350f, 
                0f, Color.white, true));
        title.setExpandToFitSpace(true);

        chart.setBackgroundPaint(new GradientPaint(0f, 0f, Color.LIGHT_GRAY, 350f, 
                0f, Color.white, true));
        chart.setTitle(title);
        //
        // get a reference to the plot for further customisation...
        CategoryPlot plot = (CategoryPlot) chart.getPlot();
        plot.setNoDataMessage("NO DATA!");
        plot.setBackgroundPaint(null);
        plot.setInsets(new RectangleInsets(10, 5, 5, 5));
        plot.setOutlinePaint(Color.black);
        plot.setRangeGridlinePaint(Color.gray);
        plot.setRangeGridlineStroke(new BasicStroke(1.0f));
        Paint[] colors = createPaint();
        CustomBarRenderer renderer = new CustomBarRenderer(colors);
        renderer.setGradientPaintTransformer(
                new StandardGradientPaintTransformer(
                        GradientPaintTransformType.CENTER_HORIZONTAL));
        plot.setRenderer(renderer);
        //
        BufferedImage image= null;
        if(nomdatos.size()<30) image = chart.createBufferedImage(584,404);
        else image = chart.createBufferedImage((nomdatos.size()*30),404);
        return image;
    }
           
    private Paint[] createPaint() {
        Paint[] colors = new Paint[nomdatos.size()];
        for(int i=0;i<nomdatos.size();i++){
            colors[i] = new GradientPaint(0f, 0f, Color.BLACK, 0f, 0f, Color.blue);            
        }
        return colors;
    }
    
    private CategoryDataset createDataset() {
        int i,num,nn;
        String nom;        
        //
        DefaultCategoryDataset dataset = new DefaultCategoryDataset();
        for(i=0;i<nomdatos.size();i++){
            nom= String.valueOf(i);       
            if(tituloG.equals("State Codes")){ nom= nomdatos.get(i).toString(); }
            if(tituloG.equals("The best download day")){ nom= this.getNomDay(Integer.parseInt(nomdatos.get(i).toString())); }
            num= Integer.parseInt(ndatos.get(i).toString()); //System.out.println("cont: " + num);
            dataset.addValue(num, tituloG, nom);
        }        
//        
        return dataset;
    }
    
    /** PASTEL GRAFICA */
    private BufferedImage creaImagenPastel(final PieDataset dataset) {
        
        final JFreeChart chart = ChartFactory.createPieChart3D(
            tituloG,  // chart title
            dataset,                // data
            poner,                   // include legend
            true,
            false
        );
        //
        TextTitle title = chart.getTitle();
        title.setBorder(0, 0, 1, 0);
        title.setBackgroundPaint(new GradientPaint(0f, 0f, Color.BLUE, 350f, 
                0f, Color.white, true));
        title.setExpandToFitSpace(true);

        chart.setBackgroundPaint(new GradientPaint(0f, 0f, Color.LIGHT_GRAY, 350f, 
                0f, Color.white, true));
        chart.setTitle(title);
        //
        final PiePlot3D plot = (PiePlot3D) chart.getPlot();
        plot.setStartAngle(290);
        plot.setDirection(Rotation.CLOCKWISE);
        plot.setForegroundAlpha(0.5f);
        plot.setNoDataMessage("No data to display");
        //
        BufferedImage image= null;
        if(nomdatos.size()<30) image = chart.createBufferedImage(584,404);
        else image = chart.createBufferedImage((nomdatos.size()*30),410);
        return image;
    }
    
    private PieDataset createPieDataset() {
        int i,num,nn;
        String nom;        
        //
        final DefaultPieDataset result = new DefaultPieDataset();
        for(i=0;i<nomdatos.size();i++){
            nom= String.valueOf(i);    
            if(tituloG.equals("State Codes")){ nom= nomdatos.get(i).toString(); }
            if(tituloG.equals("The best download day")){ nom= this.getNomDay(Integer.parseInt(nomdatos.get(i).toString())); }
            num= Integer.parseInt(ndatos.get(i).toString()); //System.out.println("cont: " + num);
            result.setValue(nom,num);
//        
        }
        return result;
        
    }
    
    /** GRAFICA DE LINEA */
    public BufferedImage creaImagenLine(){   
        //
        CategoryDataset dataset = createDataset();        
        //
        // create the chart...
        final JFreeChart chart = ChartFactory.createLineChart(
            tituloG,       // chart title
            tituloX,                    // domain axis label
            tituloY,                   // range axis label
            dataset,                   // data
            PlotOrientation.VERTICAL,  // orientation
            false,                      // include legend
            true,                      // tooltips
            false                      // urls
        );

        chart.setBackgroundPaint(Color.white);
        //
        TextTitle title = chart.getTitle();
        title.setBorder(0, 0, 1, 0);
        title.setBackgroundPaint(new GradientPaint(0f, 0f, Color.BLUE, 350f, 
                0f, Color.white, true));
        title.setExpandToFitSpace(true);

        chart.setBackgroundPaint(new GradientPaint(0f, 0f, Color.LIGHT_GRAY, 350f, 
                0f, Color.white, true));
        chart.setTitle(title);
        //

        final CategoryPlot plot = (CategoryPlot) chart.getPlot();
        plot.setBackgroundPaint(Color.white);
        plot.setRangeGridlinePaint(Color.BLACK);

        // customise the range axis...
        final NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
        rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
        rangeAxis.setAutoRangeIncludesZero(true);

        // customise the renderer...
        final LineAndShapeRenderer renderer = (LineAndShapeRenderer) plot.getRenderer();
        renderer.setBaseFillPaint(Color.BLUE);
        //
        BufferedImage image= null;
        if(nomdatos.size()<30) image = chart.createBufferedImage(584,404);
        else image = chart.createBufferedImage((nomdatos.size()*30),404);
        return image;
    }
        
    /** Creates new form graficas */
    public graficas(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        lbl_state = new javax.swing.JLabel();
        lbl_nom = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstNodos = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        lbl_graf = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        lbl_state.setText("Polaris Statistical Graphics");
        lbl_state.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lbl_nom.setText("jLabel1");

        lstNodos.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lstNodos.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lstNodosValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(lstNodos);

        lbl_graf.setBackground(new java.awt.Color(255, 255, 255));
        lbl_graf.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_graf.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/appicon.png")));
        lbl_graf.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jScrollPane2.setViewportView(lbl_graf);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 590, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lbl_nom)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 255, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18))
            .addComponent(lbl_state, javax.swing.GroupLayout.DEFAULT_SIZE, 879, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lbl_nom)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 374, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 410, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(lbl_state, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void lstNodosValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lstNodosValueChanged

    }//GEN-LAST:event_lstNodosValueChanged
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new graficas(new javax.swing.JFrame(), true).setVisible(true);
            }
        });
    }
    
     public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lbl_graf;
    private javax.swing.JLabel lbl_nom;
    private javax.swing.JLabel lbl_state;
    private javax.swing.JList lstNodos;
    // End of variables declaration//GEN-END:variables
    
    /// otra clase
    static class CustomBarRenderer extends BarRenderer {

        /** The colors. */
        private Paint[] colors;

        /**
         * Creates a new renderer.
         *
         * @param colors  the colors.
         */
        public CustomBarRenderer(Paint[] colors) {
            this.colors = colors;
        }

        /**
         * Returns the paint for an item.  Overrides the default behaviour 
         * inherited from AbstractSeriesRenderer.
         *
         * @param row  the series.
         * @param column  the category.
         *
         * @return The item color.
         */
        public Paint getItemPaint(int row, int column) {
            return this.colors[column % this.colors.length];
        }
    }
    
}
