package treeA;

import algorithm.classification.elemento;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import workspace.Prepro.intervalos;


public class Window extends javax.swing.JFrame {
    
    /** Estos parametros se guardan */
        ArrayList inDuracion;
        ArrayList inTamano;
        ArrayList inCantidad;
    // ***
         private  treeA.TreePanel treePanel2;
    
    /** Creates new form Window */
    public Window(elemento root1, String nomlog, String algorithm, String target) {
        elemento root= root1;
        Nodo rootNodo;
        //
//        root= new elemento("Raiz");        
//        root= llenar(root);        
        //




        initComponents();

        treePanel2 = new  treeA.TreePanel();
        treePanel2.setAutoscrolls(true);
        javax.swing.GroupLayout treePanel1Layout = new javax.swing.GroupLayout(treePanel2);
        treePanel2.setLayout(treePanel1Layout);
        treePanel1Layout.setHorizontalGroup(
            treePanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 691, Short.MAX_VALUE)
        );
        treePanel1Layout.setVerticalGroup(
            treePanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 601, Short.MAX_VALUE)
        );
        jScrollPane1.setViewportView(treePanel2);

        //
        this.setIconImage(this.getImage("/media/appicon.png"));        
        this.setTitle("Tree - Classification Results of: " + nomlog);
        //
        NodeUtils ejemplos= new NodeUtils();
        rootNodo= ejemplos.constructTree(root,1,null);
        //        
        List<Nodo> nodos = new ArrayList<Nodo>();
        try {
            //nodos.add(NodeUtils.constructTree(root,1,null));
            nodos= ejemplos.getNodos();
        } catch(Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        //
        //System.out.println(nodos.size());
        this.treePanel2.setNodos(nodos);
        treePanel2.setSize(100, 200);
        txt_4.setText(target);
        //
        txt_1.setEditable(false);
        txt_2.setEditable(false);
        txt_3.setEditable(false);
        txt_4.setEditable(false);
        /**Maximiza la ventana*/
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
    }
    
    public void setIntervalos(ArrayList inD, ArrayList inT, ArrayList inC){
        this.inDuracion= inD;
        this.inTamano= inT;
        this.inCantidad= inC;
    }
    
    public elemento llenar(elemento raiz){
        
        for(int i=0;i<3;i++){
                //nodo.add(armarJtree(aux.hijos[i]));
                raiz.hijos[i]= new elemento(String.valueOf(i));
                //                
            } 
        return raiz;
    }
    
    public void llenarConfig(){
        DefaultListModel model;
        String texto;
        int i;
        intervalos inter;
        //
        txt_1.setText("Duration Interval");
        txt_2.setText("Download Size Interval");
        txt_3.setText("Request Amount Interval");
        //
        if(inDuracion==null){
            /** modelo del JList lstNodos*/
            model = new DefaultListModel();
            //
            texto= "Short";
            model.addElement(texto);
            texto= "Connected less than 1/3 of the time of session ";
            model.addElement(texto); model.addElement(" ");
            texto= "Middle";
            model.addElement(texto);
            texto= "Connected between 1/3 and 2/3 of the time of session ";
            model.addElement(texto); model.addElement(" ");
            texto= "Long";
            model.addElement(texto);
            texto= "Connected more than 2/3 of the time of session ";
            model.addElement(texto);
            //
            this.lst_1.setModel(model);
        //
        }else{
            model = new DefaultListModel();
            //
            for(i=0;i<inDuracion.size();i++){
                inter= (intervalos) inDuracion.get(i);
                texto= inter.getNom();
                model.addElement(texto);
                texto= inter.getDescripcion();
                model.addElement(texto); model.addElement(" ");
            }
            //
            this.lst_1.setModel(model);
        }
        //
        if(inTamano==null){
            /** modelo del JList lstNodos*/
            model = new DefaultListModel();
            //
            texto= "Low";
            model.addElement(texto);
            texto= "Download Less than 2000 bytes";
            model.addElement(texto); model.addElement(" ");
            texto= "Middle";
            model.addElement(texto);
            texto= "Download Between 2001 and 10000 bytes";
            model.addElement(texto); model.addElement(" ");
            texto= "High";
            model.addElement(texto);
            texto= "Download More than 10001 bytes";
            model.addElement(texto);
            //
            this.lst_2.setModel(model);
        }else{
            model = new DefaultListModel();
            //
            for(i=0;i<inTamano.size();i++){
                inter= (intervalos) inTamano.get(i);
                texto= inter.getNom();
                model.addElement(texto);
                texto= inter.getDescripcion();
                model.addElement(texto); model.addElement(" ");
            }
            //
            this.lst_2.setModel(model);
        }
        //
        if(inCantidad==null){
            /** modelo del JList lstNodos*/
            model = new DefaultListModel();
            //
            texto= "Few";
            model.addElement(texto);
            texto= "Less than 10 requests";
            model.addElement(texto); model.addElement(" ");
            texto= "Middle";
            model.addElement(texto);
            texto= "Between 11 and 40 requests";
            model.addElement(texto); model.addElement(" ");
            texto= "Many";
            model.addElement(texto);
            texto= "More than 41 requests";
            model.addElement(texto);
            //
            this.lst_3.setModel(model);
        }else{
            model = new DefaultListModel();
            //
            for(i=0;i<inCantidad.size();i++){
                inter= (intervalos) inCantidad.get(i);
                texto= inter.getNom();
                model.addElement(texto);
                texto= inter.getDescripcion();
                model.addElement(texto); model.addElement(" ");
            }
            this.lst_3.setModel(model);
        }
        //
    }    
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        pnlNodes = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lst_1 = new javax.swing.JList();
        txt_1 = new javax.swing.JTextField();
        txt_2 = new javax.swing.JTextField();
        jScrollPane3 = new javax.swing.JScrollPane();
        lst_2 = new javax.swing.JList();
        jScrollPane4 = new javax.swing.JScrollPane();
        lst_3 = new javax.swing.JList();
        txt_3 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        txt_4 = new javax.swing.JTextField();

        pnlNodes.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel13.setText("INTERVALS MEAN");
        jLabel13.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lst_1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lst_1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lst_1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(lst_1);

        txt_1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txt_1.setText("Interval");

        txt_2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txt_2.setText("Interval");

        lst_2.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lst_2.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lst_2ValueChanged(evt);
            }
        });
        jScrollPane3.setViewportView(lst_2);

        lst_3.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lst_3.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lst_3ValueChanged(evt);
            }
        });
        jScrollPane4.setViewportView(lst_3);

        txt_3.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txt_3.setText("Interval");

        jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel14.setText("ATRIBUTTE TARGET");
        jLabel14.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        txt_4.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txt_4.setText("Interval");

        javax.swing.GroupLayout pnlNodesLayout = new javax.swing.GroupLayout(pnlNodes);
        pnlNodes.setLayout(pnlNodesLayout);
        pnlNodesLayout.setHorizontalGroup(
            pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlNodesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlNodesLayout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(pnlNodesLayout.createSequentialGroup()
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addContainerGap())
                        .addGroup(pnlNodesLayout.createSequentialGroup()
                            .addGroup(pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(txt_1, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel13, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(txt_4, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE))
                            .addGap(10, 10, 10))
                        .addGroup(pnlNodesLayout.createSequentialGroup()
                            .addComponent(txt_3, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlNodesLayout.createSequentialGroup()
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addContainerGap())
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlNodesLayout.createSequentialGroup()
                            .addComponent(txt_2, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                            .addContainerGap()))))
        );
        pnlNodesLayout.setVerticalGroup(
            pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlNodesLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 195, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_3, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 693, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(pnlNodes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlNodes, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 787, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void lst_3ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lst_3ValueChanged
// TODO add your handling code here:
    }//GEN-LAST:event_lst_3ValueChanged

    private void lst_2ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lst_2ValueChanged
// TODO add your handling code here:
    }//GEN-LAST:event_lst_2ValueChanged

    private void lst_1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lst_1ValueChanged
        /** este evento propio del Jlist se encarga de que el nodo que se
         * encuentre seleccionado en la lista se marque en el panel*/
    }//GEN-LAST:event_lst_1ValueChanged
    
    private void lstNodosValueChanged(javax.swing.event.ListSelectionEvent evt) {                                      
        Nodo n=null;
        int num, fin;
        /** este evento propio del Jlist se encarga de que el nodo que se
         * encuentre seleccionado en la lista se marque en el panel*/
        
    }    
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window(null,"a","C4.5","").setVisible(true);
            }
        });
    }
    
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JList lst_1;
    private javax.swing.JList lst_2;
    private javax.swing.JList lst_3;
    private javax.swing.JPanel pnlNodes;
    private javax.swing.JTextField txt_1;
    private javax.swing.JTextField txt_2;
    private javax.swing.JTextField txt_3;
    private javax.swing.JTextField txt_4;
    // End of variables declaration//GEN-END:variables
	// treeA.TreePanel

   
}
