/*
 * createRulesCla.java
 *
 * Created on 17 de agosto de 2007, 10:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package workspace.Views;

import algorithm.classification.elemento;
import algorithm.classification.sesiontrans;
import java.util.ArrayList;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class createRulesCla {
    
    ArrayList reglas;
    String ctarget;
    
    /** Creates a new instance of createRulesCla */
    public createRulesCla(elemento decisionTree, String claseTarget) {
        reglas= new ArrayList();
        ctarget= claseTarget;
        //
        sesiontrans nueva= new sesiontrans();
        armarReglas(decisionTree, nueva, "");
    }
    
    private void armarReglas(elemento aux, sesiontrans anterior, String columna){
        // Variables
        boolean isTarget=false;
        sesiontrans actual= new sesiontrans();
        actual= ponerValoresAnt(anterior);
        int i;
        i=0;
        String newcolumna="";
        // Proceso        
        if(columna.equals("") && isColumna(aux.getNombre())==true){
            newcolumna= aux.getNombre();
        }
        else{
            if(columna.equals("")){
                actual= colocarValor(ctarget, aux.getNombre(), actual);
                isTarget= true;
            }else{
                actual= colocarValor(columna, aux.getNombre(), actual);
            }
        }
        try{
            while(aux.hijos[i]!=null){
                armarReglas(aux.hijos[i], actual, newcolumna);
                //
                i++;
            }
            if(aux.hijos[i]==null && isTarget==true){
                //actual= colocarValor(ctarget, newcolumna, actual);
                reglas.add(actual);                
            }
        }catch(Exception e){
            
        }    
        // Salida        
    }//
    
    private boolean isColumna(String pcol){
        boolean loes= false;
        //
        if(pcol.equals("Ip type")) loes=true;
        if(pcol.equals("Schedule")) loes=true;
        if(pcol.equals("Week day")) loes=true;
        if(pcol.equals("Duration")) loes=true;
        if(pcol.equals("Request amount")) loes=true;
        if(pcol.equals("Download size")) loes=true;        
        //
        return loes;
    }
    
    private sesiontrans ponerValoresAnt(sesiontrans ant){
        sesiontrans nueva= new sesiontrans();
        //
        nueva.setTipoIP(ant.getTipoIP());
        nueva.setHorario(ant.getHorario());
        nueva.setDiaSemana(ant.getDiaSemana());
        nueva.setDuracion(ant.getDuracion());
        nueva.setCantPet(ant.getCantPet());
        nueva.setTamDescarga(ant.getTamDescarga());
        //
        return nueva;
    }
    
    private sesiontrans colocarValor(String columna, String Valor, sesiontrans vieja){
        sesiontrans nueva= vieja;
        //
        if(columna.equals("Ip type")){
            nueva.setTipoIP(Valor);
        }else if(columna.equals("Schedule")){
            nueva.setHorario(Valor);
        }else if(columna.equals("Week day")){
            nueva.setDiaSemana(Valor);
        }else if(columna.equals("Duration")){
            nueva.setDuracion(Valor);
        }else if(columna.equals("Request amount")){
            nueva.setCantPet(Valor);
        }else if(columna.equals("Download size")){
            nueva.setTamDescarga(Valor);
        }
        //
        return nueva;
    }
    
    public ArrayList getreglas(){
        return reglas;
    }
    
    public void MostrarReglas(){
        sesiontrans sesion;
        System.out.println(".:. REGLAS DE CLASIFICACION .:.");
        for(int i=0; i<reglas.size(); i++){
            sesion= (sesiontrans) reglas.get(i);
            System.out.println("Tipo IP: " + sesion.getTipoIP() + " = Horario: " + sesion.getHorario()
                    + " = Semana: " + sesion.getDiaSemana() + " = Duracion: " + sesion.getDuracion()
                    + " = Cantidad: " + sesion.getCantPet() + " = Tamano: " + sesion.getTamDescarga());
        }
    }
    
}
